## llvm-toolchain-snapshot 23~++20260204101751+dd02b404b020

=== flang-rt/CMakeLists.txt ===
#===-- CMakeLists.txt ------------------------------------------------------===#
#
# Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
# See https://llvm.org/LICENSE.txt for license information.
# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
#
#===------------------------------------------------------------------------===#
#
# Build instructions for the flang-rt library. This is file is intended to be
# included using the LLVM_ENABLE_RUNTIMES mechanism.
#
#===------------------------------------------------------------------------===#

if (NOT LLVM_RUNTIMES_BUILD)
  message(FATAL_ERROR "Use this CMakeLists.txt from LLVM's runtimes build system.
      Example:
        cmake <llvm-project>/runtimes -DLLVM_ENABLE_RUNTIMES=flang-rt
    ")
endif ()

set(LLVM_SUBPROJECT_TITLE "Flang-RT")
set(FLANG_RT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
set(FLANG_RT_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}")
set(FLANG_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../flang")

# CMake 3.24 is the first version of CMake that directly recognizes Flang.
# LLVM's requirement is only CMake 3.20, teach CMake 3.20-3.23 how to use Flang.
if (CMAKE_VERSION VERSION_LESS "3.24")
  cmake_path(GET CMAKE_Fortran_COMPILER STEM _Fortran_COMPILER_STEM)
  if (_Fortran_COMPILER_STEM STREQUAL "flang-new" OR _Fortran_COMPILER_STEM STREQUAL "flang")
    include(CMakeForceCompiler)
    CMAKE_FORCE_Fortran_COMPILER("${CMAKE_Fortran_COMPILER}" "LLVMFlang")

    set(CMAKE_Fortran_COMPILER_ID "LLVMFlang")
    set(CMAKE_Fortran_COMPILER_VERSION "${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}")

    set(CMAKE_Fortran_SUBMODULE_SEP "-")
    set(CMAKE_Fortran_SUBMODULE_EXT ".mod")

    set(CMAKE_Fortran_PREPROCESS_SOURCE
      "<CMAKE_Fortran_COMPILER> -cpp <DEFINES> <INCLUDES> <FLAGS> -E <SOURCE> > <PREPROCESSED_SOURCE>")

    set(CMAKE_Fortran_FORMAT_FIXED_FLAG "-ffixed-form")
    set(CMAKE_Fortran_FORMAT_FREE_FLAG "-ffree-form")

    set(CMAKE_Fortran_MODDIR_FLAG "-module-dir")

    set(CMAKE_Fortran_COMPILE_OPTIONS_PREPROCESS_ON "-cpp")
    set(CMAKE_Fortran_COMPILE_OPTIONS_PREPROCESS_OFF "-nocpp")
    set(CMAKE_Fortran_POSTPROCESS_FLAG "-ffixed-line-length-72")

    set(CMAKE_Fortran_COMPILE_OPTIONS_TARGET "--target=")

    set(CMAKE_Fortran_LINKER_WRAPPER_FLAG "-Wl,")
    set(CMAKE_Fortran_LINKER_WRAPPER_FLAG_SEP ",")
  endif ()
endif ()
enable_language(Fortran)


list(APPEND CMAKE_MODULE_PATH
    "${FLANG_RT_SOURCE_DIR}/cmake/modules"
    "${FLANG_SOURCE_DIR}/cmake/modules"
  )
include(AddFlangRT)
include(GetToolchainDirs)
include(FlangCommon)
include(HandleCompilerRT)
include(ExtendPath)


############################
# Build Mode Introspection #
############################

# Determine whether we are in the runtimes/runtimes-bins directory of a
# bootstrap build.
set(LLVM_TREE_AVAILABLE OFF)
if (LLVM_LIBRARY_OUTPUT_INTDIR AND LLVM_RUNTIME_OUTPUT_INTDIR AND PACKAGE_VERSION)
  set(LLVM_TREE_AVAILABLE ON)
endif()

# Path to LLVM development tools (FileCheck, llvm-lit, not, ...)
set(LLVM_TOOLS_DIR "${LLVM_BINARY_DIR}/bin")

# Determine build and install paths.
# The build path is absolute, but the install dir is relative, CMake's install
# command has to apply CMAKE_INSTALL_PREFIX itself.
get_toolchain_library_subdir(toolchain_lib_subdir)
if (LLVM_TREE_AVAILABLE)
  # In a bootstrap build emit the libraries into a default search path in the
  # build directory of the just-built compiler. This allows using the
  # just-built compiler without specifying paths to runtime libraries.
  #
  # Despite Clang in the name, get_clang_resource_dir does not depend on Clang
  # being added to the build. Flang uses the same resource dir as clang.
  include(GetClangResourceDir)
  get_clang_resource_dir(FLANG_RT_OUTPUT_RESOURCE_DIR PREFIX "${LLVM_LIBRARY_OUTPUT_INTDIR}/..")
  get_clang_resource_dir(FLANG_RT_INSTALL_RESOURCE_PATH_DEFAULT)

  extend_path(FLANG_RT_OUTPUT_RESOURCE_LIB_DIR "${FLANG_RT_OUTPUT_RESOURCE_DIR}" "${toolchain_lib_subdir}")
else ()
  # In a standalone runtimes build, do not write into LLVM_BINARY_DIR. It may be
  # read-only and/or shared by multiple runtimes with different build
  # configurations (e.g. Debug/Release). Use the runtime's own lib dir like any
  # non-toolchain library.
  # For the install prefix, still use the resource dir assuming that Flang will
  # be installed there using the same prefix. This is to not have a difference
  # between bootstrap and standalone runtimes builds.
  set(FLANG_RT_OUTPUT_RESOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}")
  set(FLANG_RT_INSTALL_RESOURCE_PATH_DEFAULT "lib${LLVM_LIBDIR_SUFFIX}/clang/${LLVM_VERSION_MAJOR}")

  extend_path(FLANG_RT_OUTPUT_RESOURCE_LIB_DIR "${FLANG_RT_OUTPUT_RESOURCE_DIR}" "lib${LLVM_LIBDIR_SUFFIX}")
endif ()
set(FLANG_RT_INSTALL_RESOURCE_PATH "${FLANG_RT_INSTALL_RESOURCE_PATH_DEFAULT}"
    CACHE PATH "Path to install runtime libraries to (default: clang resource dir)")
extend_path(FLANG_RT_INSTALL_RESOURCE_LIB_PATH "${FLANG_RT_INSTALL_RESOURCE_PATH}" "${toolchain_lib_subdir}")
cmake_path(NORMAL_PATH FLANG_RT_OUTPUT_RESOURCE_DIR)
cmake_path(NORMAL_PATH FLANG_RT_INSTALL_RESOURCE_PATH)
# FIXME: For the libflang_rt.so, the toolchain resource lib dir is not a good
#        destination because it is not a ld.so default search path.
#        The machine where the executable is eventually executed may not be the
#        machine where the Flang compiler and its resource dir is installed, so
#        setting RPath by the driver is not an solution. It should belong into
#        /usr/lib/<triple>/libflang_rt.so, like e.g. libgcc_s.so.
#        But the linker as invoked by the Flang driver also requires
#        libflang_rt.so to be found when linking and the resource lib dir is
#        the only reliable location.
cmake_path(NORMAL_PATH FLANG_RT_OUTPUT_RESOURCE_LIB_DIR)
cmake_path(NORMAL_PATH FLANG_RT_INSTALL_RESOURCE_LIB_PATH)


#################
# Build Options #
#################

# Important: flang-rt user options must be prefixed with "FLANG_RT_". Variables
# with this prefix will be forwarded in bootstrap builds.

# TODO: Support tests for the GPU target.
set(FLANG_RT_INCLUDE_TESTS_default ${LLVM_INCLUDE_TESTS})
if ("${LLVM_RUNTIMES_TARGET}" MATCHES "^amdgcn|^nvptx")
  set(FLANG_RT_INCLUDE_TESTS_default OFF)
endif()
option(FLANG_RT_INCLUDE_TESTS "Generate build targets for the flang-rt unit and regression-tests." "${FLANG_RT_INCLUDE_TESTS_default}")

# Provide an interface to link against the LLVM libc/libc++ projects directly.
set(FLANG_RT_SUPPORTED_PROVIDERS system llvm)
set(FLANG_RT_LIBC_PROVIDER "system" CACHE STRING "Specify C library to use. Supported values are ${FLANG_RT_SUPPORTED_PROVIDERS}.")
if (NOT "${FLANG_RT_LIBC_PROVIDER}" IN_LIST FLANG_RT_SUPPORTED_PROVIDERS)
  message(FATAL_ERROR "Unsupported library: '${FLANG_RT_RUNTIME_PROVIDER}'. Supported values are ${FLANG_RT_SUPPORTED_PROVIDERS}.")
endif ()

set(FLANG_RT_LIBCXX_PROVIDER "system" CACHE STRING "Specify C++ library to use. Supported values are ${FLANG_RT_SUPPORTED_PROVIDERS}.")
if (NOT "${FLANG_RT_LIBCXX_PROVIDER}" IN_LIST FLANG_RT_SUPPORTED_PROVIDERS)
  message(FATAL_ERROR "Unsupported library: '${FLANG_RT_LIBCXX_PROVIDER}'. Supported values are ${FLANG_RT_SUPPORTED_PROVIDERS}.")
endif ()

option(FLANG_RT_ENABLE_STATIC "Build Flang-RT as a static library." ON)
if (WIN32)
  # Windows DLL currently not implemented.
  set(FLANG_RT_ENABLE_SHARED OFF)
else ()
  # TODO: Enable by default to increase test coverage, and which version of the
  #       library should be the user's choice anyway.
  #       Currently, the Flang driver adds `-L"libdir" -lflang_rt` as linker
  #       argument, which leaves the choice which library to use to the linker.
  #       Since most linkers prefer the shared library, this would constitute a
  #       breaking change unless the driver is changed.
  option(FLANG_RT_ENABLE_SHARED "Build Flang-RT as a shared library." OFF)
endif ()
if (NOT FLANG_RT_ENABLE_STATIC AND NOT FLANG_RT_ENABLE_SHARED)
  message(FATAL_ERROR "
      Must build at least one type of library
      (FLANG_RT_ENABLE_STATIC=ON, FLANG_RT_ENABLE_SHARED=ON, or both)
    ")
endif ()


set(FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT "" CACHE STRING "Compile Flang-RT with GPU support (CUDA or OpenMP)")
set_property(CACHE FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT PROPERTY STRINGS
    ""
    CUDA
    OpenMP
  )
if (NOT FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT)
  # Support for GPUs disabled
elseif (FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT STREQUAL "CUDA")
  # Support for CUDA
  set(FLANG_RT_LIBCUDACXX_PATH "" CACHE PATH "Path to libcu++ package installation")
  option(FLANG_RT_CUDA_RUNTIME_PTX_WITHOUT_GLOBAL_VARS "Do not compile global variables' definitions when producing PTX library" OFF)
elseif (FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT STREQUAL "OpenMP")
  # Support for OpenMP offloading
  set(FLANG_RT_DEVICE_ARCHITECTURES "all" CACHE STRING
      "List of OpenMP device architectures to be used to compile the Fortran runtime (e.g. 'gfx1103;sm_90')"
    )

  if (FLANG_RT_DEVICE_ARCHITECTURES STREQUAL "all")
    # TODO: support auto detection on the build system.
    set(all_amdgpu_architectures
      "gfx700;gfx701;gfx801;gfx803;gfx900;gfx902;gfx906"
      "gfx908;gfx90a;gfx90c;gfx940;gfx1010;gfx1030"
      "gfx1031;gfx1032;gfx1033;gfx1034;gfx1035;gfx1036"
      "gfx1100;gfx1101;gfx1102;gfx1103;gfx1150;gfx1151"
      "gfx1152;gfx1153")
    set(all_nvptx_architectures
      "sm_35;sm_37;sm_50;sm_52;sm_53;sm_60;sm_61;sm_62"
      "sm_70;sm_72;sm_75;sm_80;sm_86;sm_89;sm_90")
    set(all_gpu_architectures
      "${all_amdgpu_architectures};${all_nvptx_architectures}")
      set(FLANG_RT_DEVICE_ARCHITECTURES ${all_gpu_architectures})
  endif()
  list(REMOVE_DUPLICATES FLANG_RT_DEVICE_ARCHITECTURES)
else ()
  message(FATAL_ERROR "Invalid value '${FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT}' for FLANG_RT_EXPERIMENTAL_OFFLOAD_SUPPORT; must be empty, 'CUDA', or 'OpenMP'")
endif ()


option(FLANG_RT_INCLUDE_CUF "Build the CUDA Fortran runtime (libflang_rt.cuda.a)" OFF)
if (FLANG_RT_INCLUDE_CUF)
  find_package(CUDAToolkit REQUIRED)
endif()


########################
# System Introspection #
########################

include(CheckCXXSymbolExists)
include(CheckCXXSourceCompiles)
check_cxx_symbol_exists(strerror_r string.h HAVE_STRERROR_R)
# Can't use symbol exists here as the function is overloaded in C++
check_cxx_source_compiles(
  "#include <string.h>
   int main() {
     char buf[4096];
     return strerror_s(buf, 4096, 0);
   }
  "
  HAVE_DECL_STRERROR_S)

# Search for clang_rt.builtins library. Need in addition to msvcrt.
if (WIN32)
  find_compiler_rt_library(builtins FLANG_RT_BUILTINS_LIBRARY)
endif ()

# Build with _XOPEN_SOURCE on AIX to avoid errors caused by _ALL_SOURCE.
# We need to enable the large-file API as well.
if (UNIX AND CMAKE_SYSTEM_NAME MATCHES "AIX")
  add_compile_definitions(_XOPEN_SOURCE=700)
  add_compile_definitions(_LARGE_FILE_API)
endif ()

# Check whether the compiler can undefine a macro using the "-Wp,-U" flag.
# Aternatively, we could use
#   CMAKE_CXX_COMPILER_FRONTEND_VARIANT STREQUAL "GNU"
# but some older versions of CMake don't define it for GCC itself.
check_cxx_compiler_flag("-Wp,-UTESTFLAG" FLANG_RT_SUPPORTS_UNDEFINE_FLAG)

# Check whether -fno-lto is supported.
check_cxx_compiler_flag(-fno-lto FLANG_RT_HAS_FNO_LTO_FLAG)

# Check whether -nostdlibinc is supported.
check_cxx_compiler_flag(-nostdlibinc FLANG_RT_HAS_NOSTDLIBINC_FLAG)

# Check whether -nostdlib is supported.
check_cxx_compiler_flag(-nostdlib FLANG_RT_HAS_NOSTDLIB_FLAG)

# Check whether -stdlib= is supported.
check_cxx_compiler_flag(-stdlib=platform FLANG_RT_HAS_STDLIB_FLAG)

# Check whether -Wl,--as-needed is supported.
check_linker_flag(C "LINKER:--as-needed" LINKER_SUPPORTS_AS_NEEDED)
if (LINKER_SUPPORTS_AS_NEEDED)
  set(LINKER_AS_NEEDED_OPT "LINKER:--as-needed")
endif()

# Different platform may have different name for the POSIX thread library.

=== libcxxabi/CMakeLists.txt ===
# See www/CMake.html for instructions on how to build libcxxabi with CMake.

#===============================================================================
# Setup Project
#===============================================================================

cmake_minimum_required(VERSION 3.20.0)
set(LLVM_SUBPROJECT_TITLE "libc++abi")

set(LLVM_COMMON_CMAKE_UTILS "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

# Add path for custom modules
list(INSERT CMAKE_MODULE_PATH 0
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  "${CMAKE_CURRENT_SOURCE_DIR}/../runtimes/cmake/Modules"
  "${LLVM_COMMON_CMAKE_UTILS}"
  "${LLVM_COMMON_CMAKE_UTILS}/Modules"
  )

set(CMAKE_FOLDER "libc++")

set(LIBCXXABI_SOURCE_DIR  ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBCXXABI_BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR})
set(LIBCXXABI_LIBCXX_PATH "${CMAKE_CURRENT_LIST_DIR}/../libcxx" CACHE PATH
        "Specify path to libc++ source.")

include(GNUInstallDirs)

# Require out of source build.
include(MacroEnsureOutOfSourceBuild)
MACRO_ENSURE_OUT_OF_SOURCE_BUILD(
 "${PROJECT_NAME} requires an out of source build. Please create a separate
 build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there."
 )

if (MSVC)
  message(FATAL_ERROR "Libc++abi can't be built for MSVC targets, and doing so is pointless anyway because such "
                      "targets must use the MS C++ ABI, and libc++abi provides the Itanium C++ ABI.")
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================
include(CMakeDependentOption)
include(HandleCompilerRT)

# Define options.
option(LIBCXXABI_ENABLE_EXCEPTIONS
  "Provide support for exceptions in the runtime.
  When disabled, libc++abi does not support stack unwinding and other exceptions-related features." ON)
option(LIBCXXABI_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBCXXABI_ENABLE_PEDANTIC "Compile with pedantic enabled." OFF)
option(LIBCXXABI_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBCXXABI_USE_LLVM_UNWINDER "Build and use the LLVM unwinder." ON)
if (LIBCXXABI_USE_LLVM_UNWINDER AND NOT "libunwind" IN_LIST LLVM_ENABLE_RUNTIMES)
  message(FATAL_ERROR "LIBCXXABI_USE_LLVM_UNWINDER is set to ON, but libunwind is not specified in LLVM_ENABLE_RUNTIMES.")
endif()
option(LIBCXXABI_ENABLE_STATIC_UNWINDER "Statically link the LLVM unwinder." OFF)
option(LIBCXXABI_USE_COMPILER_RT "Use compiler-rt instead of libgcc" OFF)
option(LIBCXXABI_ENABLE_THREADS "Build with threads enabled" ON)
option(LIBCXXABI_HAS_PTHREAD_API "Ignore auto-detection and force use of pthread API" OFF)
option(LIBCXXABI_HAS_WIN32_THREAD_API "Ignore auto-detection and force use of win32 thread API" OFF)
option(LIBCXXABI_HAS_EXTERNAL_THREAD_API
  "Build libc++abi with an externalized threading API.
  This option may only be set to ON when LIBCXXABI_ENABLE_THREADS=ON." OFF)
set(LIBCXXABI_AVAILABILITY_MINIMUM_HEADER_VERSION "2" CACHE STRING
  "Minimum version of the libc++ headers that are allowed to be used by binaries linked against the libc++ library. This
   version must correspond to the major version of an LLVM release.")
option(LIBCXXABI_ENABLE_FORGIVING_DYNAMIC_CAST
"Make dynamic_cast more forgiving when type_info's mistakenly have hidden \
visibility, and thus multiple type_infos can exist for a single type. \
When the dynamic_cast would normally fail, this option will cause the \
library to try comparing the type_info names to see if they are equal \
instead." OFF)

option(LIBCXXABI_ENABLE_NEW_DELETE_DEFINITIONS
  "Build libc++abi with definitions for operator new/delete. These are normally
   defined in libc++abi, but it is also possible to define them in libc++, in
   which case the definition in libc++abi should be turned off." ON)
option(LIBCXXABI_BUILD_32_BITS "Build 32 bit multilib libc++abi. This option is not supported anymore when building the runtimes. Please specify a full triple instead." ${LLVM_BUILD_32_BITS})
if (LIBCXXABI_BUILD_32_BITS)
  message(FATAL_ERROR "LIBCXXABI_BUILD_32_BITS is not supported anymore when building the runtimes, please specify a full triple instead.")
endif()

option(LIBCXXABI_INCLUDE_TESTS "Generate build targets for the libc++abi unit tests." ${LLVM_INCLUDE_TESTS})
set(LIBCXXABI_LIBDIR_SUFFIX "${LLVM_LIBDIR_SUFFIX}" CACHE STRING
    "Define suffix of library directory name (32/64)")
option(LIBCXXABI_INSTALL_HEADERS "Install the libc++abi headers." ON)
option(LIBCXXABI_INSTALL_LIBRARY "Install the libc++abi library." ON)

set(LIBCXXABI_SHARED_OUTPUT_NAME "c++abi" CACHE STRING "Output name for the shared libc++abi runtime library.")
set(LIBCXXABI_STATIC_OUTPUT_NAME "c++abi" CACHE STRING "Output name for the static libc++abi runtime library.")

set(LIBCXXABI_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}/c++/v1" CACHE STRING "Path to install the libc++abi headers at.")

if(LLVM_LIBRARY_OUTPUT_INTDIR)
  set(LIBCXXABI_GENERATED_INCLUDE_DIR "${LLVM_BINARY_DIR}/include/c++/v1")
else()
  set(LIBCXXABI_GENERATED_INCLUDE_DIR "${CMAKE_BINARY_DIR}/include/c++/v1")
endif()

set(LIBCXXABI_LIBCXX_LIBRARY_PATH "" CACHE PATH "The path to libc++ library.")
set(LIBCXXABI_LIBRARY_VERSION "1.0" CACHE STRING
"Version of libc++abi. This will be reflected in the name of the shared \
library produced. For example, -DLIBCXXABI_LIBRARY_VERSION=x.y will \
result in the library being named libc++abi.x.y.dylib, along with the \
usual symlinks pointing to that.")

# Default to building a shared library so that the default options still test
# the libc++abi that is being built. The problem with testing a static libc++abi
# is that libc++ will prefer a dynamic libc++abi from the system over a static
# libc++abi from the output directory.
option(LIBCXXABI_ENABLE_SHARED "Build libc++abi as a shared library." ON)
option(LIBCXXABI_ENABLE_STATIC "Build libc++abi as a static library." ON)

cmake_dependent_option(LIBCXXABI_INSTALL_STATIC_LIBRARY
  "Install the static libc++abi library." ON
  "LIBCXXABI_ENABLE_STATIC;LIBCXXABI_INSTALL_LIBRARY" OFF)
cmake_dependent_option(LIBCXXABI_INSTALL_SHARED_LIBRARY
  "Install the shared libc++abi library." ON
  "LIBCXXABI_ENABLE_SHARED;LIBCXXABI_INSTALL_LIBRARY" OFF)

cmake_dependent_option(LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_STATIC_LIBRARY
  "Statically link the LLVM unwinder to static library" ON
  "LIBCXXABI_ENABLE_STATIC_UNWINDER" OFF)
cmake_dependent_option(LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_SHARED_LIBRARY
  "Statically link the LLVM unwinder to shared library" ON
  "LIBCXXABI_ENABLE_STATIC_UNWINDER" OFF)

option(LIBCXXABI_BAREMETAL "Build libc++abi for baremetal targets." OFF)
# The default terminate handler attempts to demangle uncaught exceptions, which
# causes extra I/O and demangling code to be pulled in.
option(LIBCXXABI_SILENT_TERMINATE "Set this to make the terminate handler default to a silent alternative" OFF)
option(LIBCXXABI_NON_DEMANGLING_TERMINATE "Set this to make the terminate handler
avoid demangling" OFF)

if (NOT LIBCXXABI_ENABLE_SHARED AND NOT LIBCXXABI_ENABLE_STATIC)
  message(FATAL_ERROR "libc++abi must be built as either a shared or static library.")
endif()

set(LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT OFF)
if (WIN32)
  set(LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT ON)
endif()
option(LIBCXXABI_HERMETIC_STATIC_LIBRARY
  "Do not export any symbols from the static library." ${LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT})

if(MINGW)
  set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-mingw.cfg.in")
elseif(WIN32) # clang-cl
  if (LIBCXXABI_ENABLE_SHARED)
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-shared-clangcl.cfg.in")
  else()
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-static-clangcl.cfg.in")
  endif()
else()
  if (LIBCXXABI_ENABLE_SHARED)
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-shared.cfg.in")
  else()
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-static.cfg.in")
  endif()
endif()
set(LIBCXXABI_TEST_CONFIG "${LIBCXXABI_DEFAULT_TEST_CONFIG}" CACHE STRING
  "The path to the Lit testing configuration to use when running the tests.
   If a relative path is provided, it is assumed to be relative to '<monorepo>/libcxxabi/test/configs'.")
if (NOT IS_ABSOLUTE "${LIBCXXABI_TEST_CONFIG}")
  set(LIBCXXABI_TEST_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/test/configs/${LIBCXXABI_TEST_CONFIG}")
endif()
message(STATUS "Using libc++abi testing configuration: ${LIBCXXABI_TEST_CONFIG}")
set(LIBCXXABI_TEST_PARAMS "" CACHE STRING
    "A list of parameters to run the Lit test suite with.")

#===============================================================================
# Configure System
#===============================================================================

# Add path for custom modules
set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  ${CMAKE_MODULE_PATH}
  )

set(LIBCXXABI_INSTALL_RUNTIME_DIR "${CMAKE_INSTALL_BINDIR}" CACHE STRING
    "Path where built libc++abi runtime libraries should be installed.")

if(LLVM_ENABLE_PER_TARGET_RUNTIME_DIR AND NOT APPLE)
  set(LIBCXXABI_TARGET_SUBDIR ${LLVM_DEFAULT_TARGET_TRIPLE})
  if(LIBCXXABI_LIBDIR_SUBDIR)
    string(APPEND LIBCXXABI_TARGET_SUBDIR /${LIBCXXABI_LIBDIR_SUBDIR})
  endif()
  cmake_path(NORMAL_PATH LIBCXXABI_TARGET_SUBDIR)
  set(LIBCXXABI_HEADER_DIR ${LLVM_BINARY_DIR})
  set(LIBCXXABI_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR}/${LIBCXXABI_TARGET_SUBDIR})
  set(LIBCXXABI_INSTALL_LIBRARY_DIR lib${LLVM_LIBDIR_SUFFIX}/${LIBCXXABI_TARGET_SUBDIR} CACHE STRING
      "Path where built libc++abi libraries should be installed.")
  set(LIBCXXABI_INSTALL_INCLUDE_TARGET_DIR "${CMAKE_INSTALL_INCLUDEDIR}/${LIBCXXABI_TARGET_SUBDIR}/c++/v1" CACHE STRING
      "Path where target-specific libc++abi headers should be installed.")
  unset(LIBCXXABI_TARGET_SUBDIR)
else()
  if(LLVM_LIBRARY_OUTPUT_INTDIR)
    set(LIBCXXABI_HEADER_DIR ${LLVM_BINARY_DIR})
    set(LIBCXXABI_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR})
  else()
    set(LIBCXXABI_HEADER_DIR ${CMAKE_BINARY_DIR})
    set(LIBCXXABI_LIBRARY_DIR ${CMAKE_BINARY_DIR}/lib${LIBCXXABI_LIBDIR_SUFFIX})
  endif()
  set(LIBCXXABI_INSTALL_LIBRARY_DIR lib${LIBCXXABI_LIBDIR_SUFFIX} CACHE STRING
      "Path where built libc++abi libraries should be installed.")
  set(LIBCXXABI_INSTALL_INCLUDE_TARGET_DIR "${LIBCXXABI_INSTALL_INCLUDE_DIR}" CACHE STRING
      "Path where target-specific libc++abi headers should be installed.")
endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})

# By default, libcxx and libcxxabi share a library directory.
if (NOT LIBCXXABI_LIBCXX_LIBRARY_PATH)
  set(LIBCXXABI_LIBCXX_LIBRARY_PATH "${LIBCXXABI_LIBRARY_DIR}" CACHE PATH
      "The path to libc++ library." FORCE)
endif()

# Declare libc++abi configuration variables.
# They are intended for use as follows:
# LIBCXXABI_C_FLAGS: General flags for both the c++ compiler and linker.
# LIBCXXABI_CXX_FLAGS: General flags for both the c++ compiler and linker.
# LIBCXXABI_COMPILE_FLAGS: Compile only flags.
# LIBCXXABI_LINK_FLAGS: Linker only flags.
# LIBCXXABI_LIBRARIES: libraries libc++abi is linked to.

set(LIBCXXABI_C_FLAGS "")
set(LIBCXXABI_CXX_FLAGS "")
set(LIBCXXABI_COMPILE_FLAGS "")
set(LIBCXXABI_LINK_FLAGS "")
set(LIBCXXABI_LIBRARIES "")
set(LIBCXXABI_ADDITIONAL_COMPILE_FLAGS "" CACHE STRING "See documentation LIBCXX_ADDITIONAL_COMPILE_FLAGS")
set(LIBCXXABI_ADDITIONAL_LIBRARIES "" CACHE STRING
    "Additional libraries libc++abi is linked to which can be provided in cache")

# Include macros for adding and removing libc++abi flags.
include(HandleLibcxxabiFlags)

#===============================================================================
# Setup Compiler Flags

=== libc/hdr/CMakeLists.txt ===
set(LIBC_INCLUDE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBC_INCLUDE_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

include(LLVMLibCHeaderRules)

function(add_proxy_header_library target_name)
  cmake_parse_arguments(
    "ADD_PROXY_HEADER"
    "" # Optional arguments
    "" # Single value arguments
    "DEPENDS;FULL_BUILD_DEPENDS" # Multi-value arguments
    ${ARGN}
  )

  set(deps "")
  if(ADD_PROXY_HEADER_DEPENDS)
    list(APPEND deps ${ADD_PROXY_HEADER_DEPENDS})
  endif()

  if(LLVM_LIBC_FULL_BUILD AND ADD_PROXY_HEADER_FULL_BUILD_DEPENDS)
    list(APPEND deps ${ADD_PROXY_HEADER_FULL_BUILD_DEPENDS})
  endif()

  add_header_library(
    ${target_name}
    ${ADD_PROXY_HEADER_UNPARSED_ARGUMENTS}
    DEPENDS ${deps}
  )
endfunction()

add_proxy_header_library(
  math_macros
  HDRS
    math_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.math_macros
    libc.include.math
)

add_proxy_header_library(
  math_function_macros
  HDRS
    math_function_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.math_function_macros
    libc.include.math
)

add_proxy_header_library(
  errno_macros
  HDRS
    errno_macros.h
  FULL_BUILD_DEPENDS
    libc.include.errno
    libc.include.llvm-libc-macros.error_number_macros
    libc.include.llvm-libc-macros.generic_error_number_macros
)

add_header_library(fcntl_overlay HDRS fcntl_overlay.h)
add_proxy_header_library(
  fcntl_macros
  HDRS
    fcntl_macros.h
  DEPENDS
    .fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.fcntl_macros
    libc.include.fcntl
)

add_proxy_header_library(
  fenv_macros
  HDRS
    fenv_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.fenv_macros
    libc.include.fenv
)

add_proxy_header_library(
  pthread_macros
  HDRS
    pthread_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.pthread_macros
    libc.include.pthread
)

add_proxy_header_library(
  sched_macros
  HDRS
    sched_macros.h
  FULL_BUILD_DEPENDS
    libc.include.sched
    libc.include.llvm-libc-macros.sched_macros
)

add_proxy_header_library(
  signal_macros
  HDRS
    signal_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.signal_macros
    libc.include.signal
)

add_header_library(stdlib_overlay HDRS stdlib_overlay.h)

add_proxy_header_library(
  stdlib_macros
  HDRS
    stdlib_macros.h
  DEPENDS
    .stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.stdlib
    libc.include.llvm-libc-macros.stdlib_macros
)

add_header_library(stdio_overlay HDRS stdio_overlay.h)

add_proxy_header_library(
  stdio_macros
  HDRS
    stdio_macros.h
  DEPENDS
    .stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.stdio
    libc.include.llvm-libc-macros.stdio_macros
    libc.include.llvm-libc-macros.file_seek_macros
)

add_proxy_header_library(
  sys_epoll_macros
  HDRS
    sys_epoll_macros.h
  FULL_BUILD_DEPENDS
    libc.include.sys_epoll
    libc.include.llvm-libc-macros.sys_epoll_macros
)

add_proxy_header_library(
  sys_ioctl_macros
  HDRS
    sys_ioctl_macros.h
  FULL_BUILD_DEPENDS
    libc.include.sys_ioctl
    libc.include.llvm-libc-macros.sys_ioctl_macros
)

add_proxy_header_library(
  sys_stat_macros
  HDRS
    sys_stat_macros.h
  FULL_BUILD_DEPENDS
    libc.include.sys_stat
    libc.include.llvm-libc-macros.sys_stat_macros
)

add_header_library(unistd_overlay HDRS unistd_overlay.h)
add_proxy_header_library(
  unistd_macros
  HDRS
    unistd_macros.h
  DEPENDS
    .unistd_overlay
  FULL_BUILD_DEPENDS
    libc.include.unistd
    libc.include.llvm-libc-macros.unistd_macros
)

if (WIN32)
  set(windows_addtional_time_macros libc.include.llvm-libc-macros.windows.time_macros_ext)
else()
  set(windows_addtional_time_macros "")
endif()

add_proxy_header_library(
  time_macros
  HDRS
    time_macros.h
  DEPENDS
    ${windows_addtional_time_macros}
  FULL_BUILD_DEPENDS
    libc.include.time
    libc.include.llvm-libc-macros.time_macros
)

add_proxy_header_library(
  float_macros
  HDRS
    float_macros.h
  DEPENDS
    libc.include.llvm-libc-macros.float_macros
  FULL_BUILD_DEPENDS
    libc.include.float
)

add_proxy_header_library(
  limits_macros
  HDRS
    limits_macros.h
  FULL_BUILD_DEPENDS
    libc.include.limits
    libc.include.llvm-libc-macros.limits_macros
)

add_proxy_header_library(
  link_macros
  HDRS
    link_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.link_macros
    libc.include.link
)

add_proxy_header_library(
  locale_macros
  HDRS
    locale_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.locale_macros
    libc.include.locale
)

add_proxy_header_library(
  sys_auxv_macros
  HDRS
    sys_auxv_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.sys_auxv_macros
    libc.include.sys_auxv
)

add_header_library(wchar_overlay HDRS wchar_overlay.h)

add_header_library(uchar_overlay HDRS uchar_overlay.h)

add_proxy_header_library(
  wchar_macros
  HDRS
    wchar_macros.h
  DEPENDS
    .wchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.wchar_macros
    libc.include.wchar
)

# offsetof is a macro inside compiler resource header stddef.h
add_proxy_header_library(
  offsetof_macros
  HDRS
    offsetof_macros.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-macros.offsetof_macro
)

# stdint.h header.
add_proxy_header_library(
  stdint_proxy
  HDRS
    stdint_proxy.h
  FULL_BUILD_DEPENDS
    libc.include.stdint
)

add_gen_header(
  elf_proxy
  YAML_FILE
    ../libc/include/elf.yaml
  GEN_HDR
    elf_proxy.h
  DEPENDS
    libc.include.llvm_libc_common_h
    libc.include.llvm-libc-types.Elf32_Addr
    libc.include.llvm-libc-types.Elf32_Chdr
    libc.include.llvm-libc-types.Elf32_Dyn
    libc.include.llvm-libc-types.Elf32_Ehdr
    libc.include.llvm-libc-types.Elf32_Half
    libc.include.llvm-libc-types.Elf32_Lword
    libc.include.llvm-libc-types.Elf32_Nhdr
    libc.include.llvm-libc-types.Elf32_Off
    libc.include.llvm-libc-types.Elf32_Phdr
    libc.include.llvm-libc-types.Elf32_Rel
    libc.include.llvm-libc-types.Elf32_Rela
    libc.include.llvm-libc-types.Elf32_Shdr
    libc.include.llvm-libc-types.Elf32_Sword
    libc.include.llvm-libc-types.Elf32_Sym
    libc.include.llvm-libc-types.Elf32_Verdaux
    libc.include.llvm-libc-types.Elf32_Verdef
    libc.include.llvm-libc-types.Elf32_Vernaux
    libc.include.llvm-libc-types.Elf32_Verneed
    libc.include.llvm-libc-types.Elf32_Versym
    libc.include.llvm-libc-types.Elf32_Word
    libc.include.llvm-libc-types.Elf32_Xword
    libc.include.llvm-libc-types.Elf64_Addr
    libc.include.llvm-libc-types.Elf64_Chdr
    libc.include.llvm-libc-types.Elf64_Dyn
    libc.include.llvm-libc-types.Elf64_Ehdr
    libc.include.llvm-libc-types.Elf64_Half
    libc.include.llvm-libc-types.Elf64_Lword
    libc.include.llvm-libc-types.Elf64_Nhdr
    libc.include.llvm-libc-types.Elf64_Off
    libc.include.llvm-libc-types.Elf64_Phdr
    libc.include.llvm-libc-types.Elf64_Rel
    libc.include.llvm-libc-types.Elf64_Rela
    libc.include.llvm-libc-types.Elf64_Shdr
    libc.include.llvm-libc-types.Elf64_Sword
    libc.include.llvm-libc-types.Elf64_Sxword
    libc.include.llvm-libc-types.Elf64_Sym
    libc.include.llvm-libc-types.Elf64_Verdaux
    libc.include.llvm-libc-types.Elf64_Verdef
    libc.include.llvm-libc-types.Elf64_Vernaux
    libc.include.llvm-libc-types.Elf64_Verneed
    libc.include.llvm-libc-types.Elf64_Versym
    libc.include.llvm-libc-types.Elf64_Word
    libc.include.llvm-libc-types.Elf64_Xword
  PROXY
)

add_subdirectory(types)
add_subdirectory(func)

=== libc/include/CMakeLists.txt ===
set(LIBC_INCLUDE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBC_INCLUDE_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

include(LLVMLibCHeaderRules)

# The GPU build wants to install files in the compiler's resource directory.
if(LIBC_TARGET_OS_IS_GPU)
  include(GetClangResourceDir)
endif()

add_subdirectory(llvm-libc-macros)
add_subdirectory(llvm-libc-types)

add_header(
  llvm_libc_common_h
  HDR
    __llvm-libc-common.h
)

# TODO: Can we simplify this macro expansion?
# https://github.com/llvm/llvm-project/issues/117254
macro(add_header_macro TARGET_NAME YAML_FILE GEN_HDR DEPENDS)
  add_gen_header(
    ${TARGET_NAME}
    YAML_FILE ${YAML_FILE}
    GEN_HDR ${GEN_HDR}
    ${DEPENDS}
    ${ARGN}
  )
endmacro()

add_header_macro(
  ctype
  ../libc/include/ctype.yaml
  ctype.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.locale_t
)

add_header_macro(
  dirent
  ../libc/include/dirent.yaml
  dirent.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.ino_t
    .llvm-libc-types.DIR
    .llvm-libc-types.struct_dirent
)

add_header_macro(
  fcntl
  ../libc/include/fcntl.yaml
  fcntl.h
  DEPENDS
    .llvm-libc-macros.fcntl_macros
    .llvm-libc-types.mode_t
    .llvm-libc-types.struct_flock
    .llvm-libc-types.struct_flock64
    .llvm-libc-types.off64_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.off_t
    .llvm_libc_common_h
)

add_header_macro(
  dlfcn
  ../libc/include/dlfcn.yaml
  dlfcn.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.dl_info
)

add_header_macro(
  endian
  ../libc/include/endian.yaml
  endian.h
  DEPENDS
    .llvm-libc-macros.endian_macros
    .llvm_libc_common_h
)

add_header_macro(
  features
  ../libc/include/features.yaml
  features.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.features_macros
)

add_header_macro(
  fenv
  ../libc/include/fenv.yaml
  fenv.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.fenv_macros
    .llvm-libc-types.fenv_t
    .llvm-libc-types.fexcept_t
)

add_header_macro(
  stdint
  ../libc/include/stdint.yaml
  stdint.h
  DEPENDS
    .llvm-libc-macros.stdint_macros
)

add_header_macro(
  inttypes
  ../libc/include/inttypes.yaml
  inttypes.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.imaxdiv_t
    .llvm-libc-macros.inttypes_macros
    .stdint
)

add_header_macro(
  float
  ../libc/include/float.yaml
  float.h
  DEPENDS
    .llvm-libc-macros.float_macros
)

add_header_macro(
  limits
  ../libc/include/limits.yaml
  limits.h
  DEPENDS
    .llvm-libc-macros.limits_macros
)

add_header_macro(
  malloc
  ../libc/include/malloc.yaml
  malloc.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.malloc_macros
)

add_header_macro(
  math
  ../libc/include/math.yaml
  math.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.float16_macros
    .llvm-libc-macros.math_macros
    .llvm-libc-macros.math_function_macros
    .llvm-libc-types.double_t
    .llvm-libc-types.float_t
    .llvm-libc-types.float128
)

add_header_macro(
  stdfix
  ../libc/include/stdfix.yaml
  stdfix.h
  DEPENDS
    .llvm-libc-macros.stdfix_macros
    .llvm-libc-types.int_hk_t
    .llvm-libc-types.int_hr_t
    .llvm-libc-types.int_k_t
    .llvm-libc-types.int_lk_t
    .llvm-libc-types.int_lr_t
    .llvm-libc-types.int_r_t
    .llvm-libc-types.uint_uhk_t
    .llvm-libc-types.uint_uhr_t
    .llvm-libc-types.uint_uk_t
    .llvm-libc-types.uint_ulk_t
    .llvm-libc-types.uint_ulr_t
    .llvm-libc-types.uint_ur_t
)


add_header_macro(
  sysexits
  ../libc/include/sysexits.yaml
  sysexits.h
  DEPENDS
    .llvm-libc-macros.sysexits_macros
)


# TODO: This should be conditional on POSIX networking being included.
file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/arpa)

add_header_macro(
  arpa_inet
  ../libc/include/arpa/inet.yaml
  arpa/inet.h
  DEPENDS
    .llvm_libc_common_h
    .inttypes
    .llvm-libc-types.in_addr
    .llvm-libc-types.in_addr_t
)

file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/netinet)

add_header_macro(
  netinet_in
  ../libc/include/netinet/in.yaml
  netinet/in.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.netinet_in_macros
)

add_header_macro(
  assert
  ../libc/include/assert.yaml
  assert.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.assert_macros
)

add_header_macro(
  complex
  ../libc/include/complex.yaml
  complex.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.complex_macros
    .llvm-libc-types.float128
    .llvm-libc-types.cfloat128
    .llvm-libc-types.cfloat16
)

add_header_macro(
  setjmp
  ../libc/include/setjmp.yaml
  setjmp.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.jmp_buf
    .llvm-libc-types.sigjmp_buf
)

add_header_macro(
  string
  ../libc/include/string.yaml
  string.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.null_macro
    .llvm-libc-types.size_t
)

add_header_macro(
  strings
  ../libc/include/strings.yaml
  strings.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.size_t
)

add_header_macro(
  search
  ../libc/include/search.yaml
  search.h
  DEPENDS
    .llvm-libc-types.ACTION
    .llvm-libc-types.ENTRY
    .llvm-libc-types.VISIT
    .llvm-libc-types.__search_compare_t
    .llvm-libc-types.size_t
    .llvm-libc-types.struct_hsearch_data
    .llvm_libc_common_h
)

add_header_macro(
  time
  ../libc/include/time.yaml
  time.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.time_macros
    .llvm-libc-types.clock_t
    .llvm-libc-types.time_t
    .llvm-libc-types.struct_tm
    .llvm-libc-types.struct_timespec
    .llvm-libc-types.struct_timeval
    .llvm-libc-types.clockid_t
)

add_header_macro(
  threads
  ../libc/include/threads.yaml
  threads.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.__call_once_func_t
    .llvm-libc-types.once_flag
    .llvm-libc-types.cnd_t
    .llvm-libc-types.mtx_t
    .llvm-libc-types.thrd_t
    .llvm-libc-types.thrd_start_t
    .llvm-libc-types.tss_t
    .llvm-libc-types.tss_dtor_t
)

add_header_macro(
  errno
  ../libc/include/errno.yaml
  errno.h
  DEPENDS
    .llvm-libc-macros.generic_error_number_macros
    .llvm-libc-macros.error_number_macros
)

add_header_macro(
  signal
  ../libc/include/signal.yaml
  signal.h
  DEPENDS
    .llvm-libc-macros.signal_macros
    .llvm-libc-types.pid_t
    .llvm-libc-types.sig_atomic_t
    .llvm-libc-types.sighandler_t
    .llvm-libc-types.siginfo_t
    .llvm-libc-types.sigset_t
    .llvm-libc-types.stack_t
    .llvm-libc-types.struct_sigaction
    .llvm-libc-types.union_sigval
)

add_header_macro(
  stdbit
  ../libc/include/stdbit.yaml
  stdbit.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.stdbit_macros
)

add_header_macro(
  stdckdint
  ../libc/include/stdckdint.yaml
  stdckdint.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.stdckdint_macros
)

add_header_macro(
  stdio
  ../libc/include/stdio.yaml
  stdio.h
  DEPENDS
    .llvm-libc-macros.file_seek_macros
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.stdio_macros
    .llvm-libc-types.FILE
    .llvm-libc-types.cookie_io_functions_t
    .llvm-libc-types.off_t
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
    .llvm_libc_common_h
)

add_header_macro(
  stdlib
  ../libc/include/stdlib.yaml
  stdlib.h
  DEPENDS
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.stdlib_macros
    .llvm-libc-types.__atexithandler_t
    .llvm-libc-types.__qsortcompare_t
    .llvm-libc-types.__qsortrcompare_t
    .llvm-libc-types.__search_compare_t
    .llvm-libc-types.div_t
    .llvm-libc-types.ldiv_t
    .llvm-libc-types.lldiv_t
    .llvm-libc-types.locale_t
    .llvm-libc-types.size_t
    .llvm_libc_common_h
)

add_header_macro(
  unistd
  ../libc/include/unistd.yaml
  unistd.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.file_seek_macros
    .llvm-libc-macros.unistd_macros
    .llvm-libc-types.__exec_argv_t
    .llvm-libc-types.__exec_envp_t
    .llvm-libc-types.off_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
    .llvm-libc-types.uid_t
    .llvm-libc-types.__getoptargv_t
)

add_header_macro(
  pthread
  ../libc/include/pthread.yaml
  pthread.h
  DEPENDS
    .llvm-libc-macros.pthread_macros
    .llvm-libc-types.__atfork_callback_t
    .llvm-libc-types.__pthread_once_func_t
    .llvm-libc-types.__pthread_start_t
    .llvm-libc-types.__pthread_tss_dtor_t
    .llvm-libc-types.pthread_attr_t
    .llvm-libc-types.pthread_condattr_t
    .llvm-libc-types.pthread_key_t
    .llvm-libc-types.pthread_barrier_t
    .llvm-libc-types.pthread_barrierattr_t
    .llvm-libc-types.pthread_mutex_t
    .llvm-libc-types.pthread_mutexattr_t
    .llvm-libc-types.pthread_once_t
    .llvm-libc-types.pthread_rwlock_t
    .llvm-libc-types.pthread_rwlockattr_t
    .llvm-libc-types.pthread_spinlock_t
    .llvm-libc-types.pthread_t
    .llvm_libc_common_h
)

add_header_macro(
  sched
  ../libc/include/sched.yaml
  sched.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sched_macros
    .llvm-libc-types.cpu_set_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.size_t
    .llvm-libc-types.struct_sched_param
    # Needed according to posix standard
    .llvm-libc-types.time_t
    .llvm-libc-types.struct_timespec
)

add_header_macro(
  spawn
  ../libc/include/spawn.yaml
  spawn.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.mode_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.posix_spawnattr_t
    .llvm-libc-types.posix_spawn_file_actions_t
)

add_header_macro(
  link
  ../libc/include/link.yaml
  link.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.link_macros
    .llvm-libc-types.struct_dl_phdr_info
    .llvm-libc-types.__dl_iterate_phdr_callback_t
)

add_header_macro(
  elf
  ../libc/include/elf.yaml
  elf.h
  DEPENDS
    .llvm-libc-macros.elf_macros
    .llvm-libc-types.Elf32_Addr
    .llvm-libc-types.Elf32_Chdr
    .llvm-libc-types.Elf32_Dyn
    .llvm-libc-types.Elf32_Ehdr
    .llvm-libc-types.Elf32_Half
    .llvm-libc-types.Elf32_Lword
    .llvm-libc-types.Elf32_Nhdr
    .llvm-libc-types.Elf32_Off
    .llvm-libc-types.Elf32_Phdr
    .llvm-libc-types.Elf32_Rel
    .llvm-libc-types.Elf32_Rela
    .llvm-libc-types.Elf32_Shdr
    .llvm-libc-types.Elf32_Sword
    .llvm-libc-types.Elf32_Sym
    .llvm-libc-types.Elf32_Verdaux
    .llvm-libc-types.Elf32_Verdef
    .llvm-libc-types.Elf32_Vernaux
    .llvm-libc-types.Elf32_Verneed
    .llvm-libc-types.Elf32_Versym
    .llvm-libc-types.Elf32_Word
    .llvm-libc-types.Elf32_Xword
    .llvm-libc-types.Elf64_Addr
    .llvm-libc-types.Elf64_Chdr
    .llvm-libc-types.Elf64_Dyn
    .llvm-libc-types.Elf64_Ehdr
    .llvm-libc-types.Elf64_Half
    .llvm-libc-types.Elf64_Lword
    .llvm-libc-types.Elf64_Nhdr
    .llvm-libc-types.Elf64_Off
    .llvm-libc-types.Elf64_Phdr
    .llvm-libc-types.Elf64_Rel
    .llvm-libc-types.Elf64_Rela
    .llvm-libc-types.Elf64_Shdr
    .llvm-libc-types.Elf64_Sword
    .llvm-libc-types.Elf64_Sxword
    .llvm-libc-types.Elf64_Sym
    .llvm-libc-types.Elf64_Verdaux
    .llvm-libc-types.Elf64_Verdef
    .llvm-libc-types.Elf64_Vernaux
    .llvm-libc-types.Elf64_Verneed
    .llvm-libc-types.Elf64_Versym
    .llvm-libc-types.Elf64_Word
    .llvm-libc-types.Elf64_Xword
)

# TODO: Not all platforms will have a include/sys directory. Add the sys
# directory and the targets for sys/*.h files conditional to the OS requiring
# them.
file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/sys)

add_header_macro(
  sys_auxv
  ../libc/include/sys/auxv.yaml
  sys/auxv.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_auxv_macros
)

add_header_macro(
  sys_epoll
  ../libc/include/sys/epoll.yaml
  sys/epoll.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.struct_epoll_event
    .llvm-libc-types.struct_epoll_data
    .llvm-libc-types.sigset_t
    .llvm-libc-macros.sys_epoll_macros
)

add_header_macro(
  sys_ioctl
  ../libc/include/sys/ioctl.yaml
  sys/ioctl.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_ioctl_macros
)

add_header_macro(
  sys_mman
  ../libc/include/sys/mman.yaml
  sys/mman.h
  DEPENDS

=== libcxxabi/src/CMakeLists.txt ===
# Get sources
set(LIBCXXABI_SOURCES
  # C++ABI files
  cxa_aux_runtime.cpp
  cxa_default_handlers.cpp
  cxa_demangle.cpp
  cxa_exception_storage.cpp
  cxa_guard.cpp
  cxa_handlers.cpp
  cxa_vector.cpp
  cxa_virtual.cpp
  # C++ STL files
  stdlib_exception.cpp
  stdlib_stdexcept.cpp
  stdlib_typeinfo.cpp
  # Internal files
  abort_message.cpp
  fallback_malloc.cpp
  private_typeinfo.cpp
)

if (LIBCXXABI_ENABLE_NEW_DELETE_DEFINITIONS)
  list(APPEND LIBCXXABI_SOURCES
    stdlib_new_delete.cpp
  )
endif()

if (LIBCXXABI_ENABLE_EXCEPTIONS)
  list(APPEND LIBCXXABI_SOURCES
    cxa_exception.cpp
    cxa_personality.cpp
  )
else()
  list(APPEND LIBCXXABI_SOURCES
    cxa_noexception.cpp
  )
endif()

if (LIBCXXABI_ENABLE_THREADS AND (UNIX OR FUCHSIA) AND NOT (APPLE OR CYGWIN)
    AND NOT ("${CMAKE_SYSTEM_NAME}" MATCHES "AIX"))
  list(APPEND LIBCXXABI_SOURCES
    cxa_thread_atexit.cpp
  )
endif()

set(LIBCXXABI_HEADERS
  ../include/cxxabi.h
)

# Add all the headers to the project for IDEs.
if (MSVC_IDE OR XCODE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  if (MSVC_IDE)
    source_group("Header Files" FILES ${LIBCXXABI_HEADERS})
  endif()
endif()

# Some files depend on libc++ internals.
include_directories("${LIBCXXABI_LIBCXX_PATH}/src")

if (LIBCXXABI_HAS_CXA_THREAD_ATEXIT_IMPL)
  add_definitions(-DHAVE___CXA_THREAD_ATEXIT_IMPL)
endif()

if (LIBCXXABI_ENABLE_FORGIVING_DYNAMIC_CAST)
  add_definitions(-D_LIBCXXABI_FORGIVING_DYNAMIC_CAST)
endif()

if (NOT APPLE) # On Apple platforms, we always use -nostdlib++ so we don't need to re-add other libraries
  if (LIBCXXABI_ENABLE_THREADS)
    add_library_flags_if(LIBCXXABI_HAS_PTHREAD_LIB pthread)
  endif()

  add_library_flags_if(LIBCXXABI_HAS_C_LIB c)
endif()

if (FUCHSIA)
    # TODO: Use CMAKE_LINK_LIBRARY_USING_FEATURE once our minimum CMake is at least 3.24
    # https://cmake.org/cmake/help/latest/variable/CMAKE_LINK_LIBRARY_USING_FEATURE.html
    add_link_flags("-Wl,--push-state,--as-needed,-lzircon,--pop-state")
endif()

if (NOT LIBCXXABI_USE_COMPILER_RT)
  add_library_flags_if(LIBCXXABI_HAS_GCC_LIB gcc)
endif()
if (NOT LIBCXXABI_USE_LLVM_UNWINDER)
  add_library_flags_if(LIBCXXABI_HAS_GCC_S_LIB gcc_s)
endif()

if (MINGW)
  # MINGW_LIBRARIES is defined in config-ix.cmake
  list(APPEND LIBCXXABI_LIBRARIES ${MINGW_LIBRARIES})
endif()
if (ANDROID AND ANDROID_PLATFORM_LEVEL LESS 21)
  list(APPEND LIBCXXABI_LIBRARIES android_support)
endif()

# Setup flags.
if (CXX_SUPPORTS_NOSTDLIBXX_FLAG)
  add_link_flags_if_supported(-nostdlib++)
else()
  add_link_flags_if_supported(-nodefaultlibs)
endif()

if (CXX_SUPPORTS_UNWINDLIB_EQ_NONE_FLAG AND LIBCXXABI_USE_LLVM_UNWINDER)
  # If we're linking directly against the libunwind that we're building
  # in the same invocation, don't try to link in the toolchain's
  # default libunwind (which may be missing still).
  add_link_flags_if_supported(--unwindlib=none)
endif()

if ( APPLE )
  if (LLVM_USE_SANITIZER)
    if (("${LLVM_USE_SANITIZER}" STREQUAL "Address") OR
        ("${LLVM_USE_SANITIZER}" STREQUAL "Address;Undefined") OR
        ("${LLVM_USE_SANITIZER}" STREQUAL "Undefined;Address"))
      set(LIBFILE "libclang_rt.asan_osx_dynamic.dylib")
    elseif("${LLVM_USE_SANITIZER}" STREQUAL "Undefined")
      set(LIBFILE "libclang_rt.ubsan_osx_dynamic.dylib")
    elseif("${LLVM_USE_SANITIZER}" STREQUAL "Thread")
      set(LIBFILE "libclang_rt.tsan_osx_dynamic.dylib")
    else()
      message(WARNING "LLVM_USE_SANITIZER=${LLVM_USE_SANITIZER} is not supported on OS X")
    endif()
    if (LIBFILE)
      find_compiler_rt_library(builtins LIBCXXABI_BUILTINS_LIBRARY)
      get_filename_component(LIBDIR "${LIBCXXABI_BUILTINS_LIBRARY}" DIRECTORY)
      if (NOT IS_DIRECTORY "${LIBDIR}")
        message(FATAL_ERROR "Cannot find compiler-rt directory on OS X required for LLVM_USE_SANITIZER")
      endif()
      set(LIBCXXABI_SANITIZER_LIBRARY "${LIBDIR}/${LIBFILE}")
      set(LIBCXXABI_SANITIZER_LIBRARY "${LIBCXXABI_SANITIZER_LIBRARY}" PARENT_SCOPE)
      message(STATUS "Manually linking compiler-rt library: ${LIBCXXABI_SANITIZER_LIBRARY}")
      add_library_flags("${LIBCXXABI_SANITIZER_LIBRARY}")
      add_link_flags("-Wl,-rpath,${LIBDIR}")
    endif()
  endif()

  # Make sure we link in CrashReporterClient if we find it -- it's used by
  # abort() on Apple platforms when building the system dylib.
  find_library(CrashReporterClient NAMES libCrashReporterClient.a
                                   PATHS "${CMAKE_OSX_SYSROOT}/usr/local/lib")
  if (CrashReporterClient)
    message(STATUS "Linking with CrashReporterClient at ${CrashReporterClient}")
    add_library_flags("${CrashReporterClient}")
  else()
    message(STATUS "Could not find CrashReporterClient, not linking against it")
  endif()
endif()

split_list(LIBCXXABI_COMPILE_FLAGS)
split_list(LIBCXXABI_LINK_FLAGS)

# FIXME: libc++abi.so will not link when modules are enabled because it depends
# on symbols defined in libc++.so which has not yet been built.
if (LLVM_ENABLE_MODULES)
  string(REPLACE "-Wl,-z,defs" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
endif()

include(WarningFlags)

# Build the shared library.
add_library(cxxabi_shared_objects OBJECT EXCLUDE_FROM_ALL ${LIBCXXABI_SOURCES} ${LIBCXXABI_HEADERS})
cxx_add_warning_flags(cxxabi_shared_objects ${LIBCXXABI_ENABLE_WERROR} ${LIBCXXABI_ENABLE_PEDANTIC})
if (LIBCXXABI_USE_LLVM_UNWINDER)
  if (LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_SHARED_LIBRARY OR
      (DEFINED LIBUNWIND_ENABLE_SHARED AND NOT LIBUNWIND_ENABLE_SHARED))
    target_link_libraries(cxxabi_shared_objects PUBLIC unwind_shared_objects) # propagate usage requirements
    target_sources(cxxabi_shared_objects PUBLIC $<TARGET_OBJECTS:unwind_shared_objects>)
  else()
    target_link_libraries(cxxabi_shared_objects PUBLIC unwind_shared)
  endif()
endif()
target_link_libraries(cxxabi_shared_objects
  PUBLIC cxxabi-headers
  PRIVATE cxx-headers runtimes-libc-headers ${LIBCXXABI_LIBRARIES})
if (NOT CXX_SUPPORTS_NOSTDLIBXX_FLAG)
  target_link_libraries(cxxabi_shared_objects PRIVATE ${LIBCXXABI_BUILTINS_LIBRARY})
endif()
set_target_properties(cxxabi_shared_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 23
    CXX_STANDARD_REQUIRED OFF # TODO: Make this REQUIRED once we don't need to accommodate the LLVM documentation builders using an ancient CMake
    COMPILE_FLAGS "${LIBCXXABI_COMPILE_FLAGS}"
    DEFINE_SYMBOL ""
)
if (CMAKE_POSITION_INDEPENDENT_CODE OR NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set_target_properties(cxxabi_shared_objects PROPERTIES POSITION_INDEPENDENT_CODE ON) # must set manually because it's an object library
endif()
target_compile_options(cxxabi_shared_objects PRIVATE "${LIBCXXABI_ADDITIONAL_COMPILE_FLAGS}")

# Build with -fsized-deallocation, which is default in recent versions of Clang.
# TODO(LLVM 21): This can be dropped once we only support Clang >= 19.
target_add_compile_flags_if_supported(cxxabi_shared_objects PRIVATE -fsized-deallocation)

add_library(cxxabi_shared SHARED)
set_target_properties(cxxabi_shared
  PROPERTIES
    EXCLUDE_FROM_ALL "$<IF:$<BOOL:${LIBCXXABI_ENABLE_SHARED}>,FALSE,TRUE>"
    LINK_FLAGS "${LIBCXXABI_LINK_FLAGS}"
    OUTPUT_NAME "${LIBCXXABI_SHARED_OUTPUT_NAME}"
    SOVERSION "1"
    VERSION "${LIBCXXABI_LIBRARY_VERSION}"
)

if (ZOS)
  add_custom_command(TARGET cxxabi_shared POST_BUILD
    COMMAND
      ${LIBCXXABI_LIBCXX_PATH}/utils/zos_rename_dll_side_deck.sh
      $<TARGET_LINKER_FILE_NAME:cxxabi_shared> $<TARGET_FILE_NAME:cxxabi_shared> "${LIBCXXABI_DLL_NAME}"
    COMMENT "Rename dll name inside the side deck file"
    WORKING_DIRECTORY $<TARGET_FILE_DIR:cxxabi_shared>
  )
endif ()

target_link_libraries(cxxabi_shared
  PUBLIC cxxabi_shared_objects runtimes-libc-shared
  PRIVATE ${LIBCXXABI_LIBRARIES})

# TODO: Move this to libc++'s HandleLibCXXABI.cmake since this is effectively trying to control
#       what libc++ re-exports.
add_library(cxxabi-reexports INTERFACE)
function(export_symbols file)
  # -exported_symbols_list is only available on Apple platforms
  if (APPLE)
    target_link_libraries(cxxabi_shared PRIVATE "-Wl,-exported_symbols_list,${file}")
  endif()
endfunction()

function(reexport_symbols file)
  export_symbols("${file}")
  # -reexported_symbols_list is only available on Apple platforms
  if (APPLE)
    target_link_libraries(cxxabi-reexports INTERFACE "-Wl,-reexported_symbols_list,${file}")
  endif()
endfunction()

export_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/symbols-not-reexported.exp")
reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/cxxabiv1.exp")
reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/fundamental-types.exp")
reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/itanium-base.exp")
reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/std-misc.exp")

if (LIBCXXABI_ENABLE_NEW_DELETE_DEFINITIONS)
  reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/new-delete.exp")
endif()

# Note that std:: exception types are always defined by the library regardless of
# whether the exception runtime machinery is provided.
reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/std-exceptions.exp")

if (LIBCXXABI_ENABLE_EXCEPTIONS)
  reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/itanium-exceptions.exp")

  if ("${CMAKE_OSX_ARCHITECTURES}" MATCHES "^(armv6|armv7|armv7s)$")
    reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/personality-sjlj.exp")
  else()
    reexport_symbols("${CMAKE_CURRENT_SOURCE_DIR}/../lib/personality-v0.exp")
  endif()
endif()

# Build the static library.
add_library(cxxabi_static_objects OBJECT EXCLUDE_FROM_ALL ${LIBCXXABI_SOURCES} ${LIBCXXABI_HEADERS})
cxx_add_warning_flags(cxxabi_static_objects ${LIBCXXABI_ENABLE_WERROR} ${LIBCXXABI_ENABLE_PEDANTIC})
if (LIBCXXABI_USE_LLVM_UNWINDER AND LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_STATIC_LIBRARY)
  target_link_libraries(cxxabi_static_objects PUBLIC unwind_static_objects) # propagate usage requirements
  target_sources(cxxabi_static_objects PUBLIC $<TARGET_OBJECTS:unwind_static_objects>)
endif()
target_link_libraries(cxxabi_static_objects
  PUBLIC cxxabi-headers
  PRIVATE cxx-headers runtimes-libc-headers ${LIBCXXABI_STATIC_LIBRARIES} ${LIBCXXABI_LIBRARIES})
set_target_properties(cxxabi_static_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 23
    CXX_STANDARD_REQUIRED OFF # TODO: Make this REQUIRED once we don't need to accommodate the LLVM documentation builders using an ancient CMake
    COMPILE_FLAGS "${LIBCXXABI_COMPILE_FLAGS}"
)
target_compile_options(cxxabi_static_objects PRIVATE "${LIBCXXABI_ADDITIONAL_COMPILE_FLAGS}")

# Build with -fsized-deallocation, which is default in recent versions of Clang.
# TODO(LLVM 21): This can be dropped once we only support Clang >= 19.
target_add_compile_flags_if_supported(cxxabi_static_objects PRIVATE -fsized-deallocation)

if(LIBCXXABI_HERMETIC_STATIC_LIBRARY)
  target_add_compile_flags_if_supported(cxxabi_static_objects PRIVATE -fvisibility=hidden)
  # If the hermetic library doesn't define the operator new/delete functions
  # then its code shouldn't declare them with hidden visibility.  They might
  # actually be provided by a shared library at link time.
  if (LIBCXXABI_ENABLE_NEW_DELETE_DEFINITIONS)
    target_add_compile_flags_if_supported(cxxabi_static_objects PRIVATE -fvisibility-global-new-delete=force-hidden)
    if (NOT CXX_SUPPORTS_FVISIBILITY_GLOBAL_NEW_DELETE_EQ_FORCE_HIDDEN_FLAG)
      target_add_compile_flags_if_supported(cxxabi_static_objects PRIVATE -fvisibility-global-new-delete-hidden)
    endif()
  endif()
  # _LIBCPP_DISABLE_VISIBILITY_ANNOTATIONS can be defined in libcxx's
  # __config_site too. Define it in the same way here, to avoid redefinition
  # conflicts.
  target_compile_definitions(cxxabi_static_objects
    PRIVATE
      _LIBCXXABI_DISABLE_VISIBILITY_ANNOTATIONS
      _LIBCPP_DISABLE_VISIBILITY_ANNOTATIONS=)
endif()

add_library(cxxabi_static STATIC)

=== libcxxabi/test/CMakeLists.txt ===
include(AddLLVM) # for configure_lit_site_cfg and add_lit_testsuite
include(HandleLitArguments)
macro(pythonize_bool var)
  if (${var})
    set(${var} True)
  else()
    set(${var} False)
  endif()
endmacro()

# Install the library and its dependencies at a fake location so we can run the test
# suite against it. This ensures that we run the test suite against a setup that matches
# what we ship in production as closely as possible (in terms of file paths, rpaths, etc).
set(LIBCXXABI_TESTING_INSTALL_PREFIX "${LIBCXXABI_BINARY_DIR}/test-suite-install")
set(libcxxabi_test_suite_install_targets cxx-headers cxx cxx-modules cxxabi-headers cxxabi)
if (LIBCXXABI_USE_LLVM_UNWINDER AND TARGET unwind)
  list(APPEND libcxxabi_test_suite_install_targets unwind-headers unwind)
endif()
foreach(target IN LISTS libcxxabi_test_suite_install_targets)
  add_custom_target(libcxxabi-test-suite-install-${target} DEPENDS "${target}"
                    COMMAND "${CMAKE_COMMAND}" --install "${CMAKE_BINARY_DIR}"
                                               --prefix "${LIBCXXABI_TESTING_INSTALL_PREFIX}"
                                               --component "${target}")
  add_dependencies(cxxabi-test-depends libcxxabi-test-suite-install-${target})
endforeach()

pythonize_bool(LIBCXXABI_USE_LLVM_UNWINDER)

set(AUTO_GEN_COMMENT "## Autogenerated by libcxxabi configuration.\n# Do not edit!")
set(SERIALIZED_LIT_PARAMS "# Lit parameters serialized here for llvm-lit to pick them up\n")

serialize_lit_string_param(SERIALIZED_LIT_PARAMS compiler "${CMAKE_CXX_COMPILER}")

if (NOT LIBCXXABI_ENABLE_EXCEPTIONS)
  serialize_lit_param(SERIALIZED_LIT_PARAMS enable_exceptions False)
endif()

if (LIBCXXABI_ENABLE_ASSERTIONS)
  serialize_lit_param(SERIALIZED_LIT_PARAMS enable_assertions True)
endif()

serialize_lit_param(SERIALIZED_LIT_PARAMS enable_experimental False)

if (LLVM_USE_SANITIZER)
  serialize_lit_string_param(SERIALIZED_LIT_PARAMS use_sanitizer "${LLVM_USE_SANITIZER}")
endif()

if (CMAKE_CXX_COMPILER_TARGET)
  serialize_lit_string_param(SERIALIZED_LIT_PARAMS target_triple "${CMAKE_CXX_COMPILER_TARGET}")
else()
  serialize_lit_string_param(SERIALIZED_LIT_PARAMS target_triple "${LLVM_DEFAULT_TARGET_TRIPLE}")
endif()

serialize_lit_params_list(SERIALIZED_LIT_PARAMS LIBCXXABI_TEST_PARAMS)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/configs/cmake-bridge.cfg.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake-bridge.cfg"
               @ONLY)

configure_lit_site_cfg(
  "${LIBCXXABI_TEST_CONFIG}"
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg
  MAIN_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py")

add_lit_testsuite(check-cxxabi "Running libcxxabi tests"
  ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS cxxabi-test-depends)

=== libunwind/include/CMakeLists.txt ===
set(files
    __libunwind_config.h
    libunwind.h
    libunwind.modulemap
    mach-o/compact_unwind_encoding.h
    unwind_arm_ehabi.h
    unwind_itanium.h
    unwind.h
    )

add_library(unwind-headers INTERFACE)
target_include_directories(unwind-headers INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

if(LIBUNWIND_INSTALL_HEADERS)
  foreach(file ${files})
    get_filename_component(dir ${file} DIRECTORY)
    install(FILES ${file}
      DESTINATION "${LIBUNWIND_INSTALL_INCLUDE_DIR}/${dir}"
      COMPONENT unwind-headers
      PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
    )
  endforeach()

  if (NOT CMAKE_CONFIGURATION_TYPES)
    add_custom_target(install-unwind-headers
      DEPENDS unwind-headers
      COMMAND "${CMAKE_COMMAND}" --install "${CMAKE_BINARY_DIR}" --component unwind-headers)
    add_custom_target(install-unwind-headers-stripped DEPENDS install-unwind-headers)
  endif()
endif()

=== lldb/docs/CMakeLists.txt ===
include(FindDoxygen)

if(DOXYGEN_FOUND)
  set(abs_top_srcdir ${CMAKE_CURRENT_SOURCE_DIR}/..)
  set(DOT dot)
  set(PACKAGE_VERSION mainline)
  set(abs_top_builddir ..)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doxygen.cfg.in
  ${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg @ONLY)

  add_custom_target(lldb-cpp-doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating LLDB C++ API reference with Doxygen" VERBATIM
  )
  set_target_properties(lldb-cpp-doc PROPERTIES FOLDER "LLDB/Docs")
endif()

if (LLVM_ENABLE_SPHINX)
  include(AddSphinxTarget)
endif()

if (LLDB_ENABLE_PYTHON AND SPHINX_FOUND)
  if (${SPHINX_OUTPUT_HTML})
    # Pretend that the SWIG generated API is a Python package.
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lldb)
    get_target_property(lldb_bindings_dir swig_wrapper_python BINARY_DIR)
    add_custom_target(lldb-python-doc-package
      COMMAND "${CMAKE_COMMAND}" -E copy "${lldb_bindings_dir}/lldb.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/__init__.py"
      COMMAND "${CMAKE_COMMAND}" -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins"
      COMMAND "${CMAKE_COMMAND}" -E copy "${LLDB_SOURCE_DIR}/examples/python/templates/scripted_frame_provider.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins/"
      COMMAND "${CMAKE_COMMAND}" -E copy "${LLDB_SOURCE_DIR}/examples/python/templates/scripted_process.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins/"
      COMMAND "${CMAKE_COMMAND}" -E copy "${LLDB_SOURCE_DIR}/examples/python/templates/scripted_platform.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins/"
      COMMAND "${CMAKE_COMMAND}" -E copy "${LLDB_SOURCE_DIR}/examples/python/templates/operating_system.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins/"
      COMMAND "${CMAKE_COMMAND}" -E copy "${LLDB_SOURCE_DIR}/examples/python/templates/scripted_thread_plan.py" "${CMAKE_CURRENT_BINARY_DIR}/lldb/plugins/"
      COMMENT "Copying lldb.py to pretend its a Python package.")

    add_dependencies(lldb-python-doc-package swig_wrapper_python)

    # FIXME: Don't treat Sphinx warnings as errors. The files generated by
    # automodapi are full of warnings (partly caused by SWIG, our documentation
    # and probably also automodapi itself), so those warnings need to be fixed
    # first before we can turn this on.
    set(SPHINX_WARNINGS_AS_ERRORS Off)

    # The sphinx config needs to know where the generated LLDB Python module is.
    # There is no way to pass a variable into our sphinx config, so just pass
    # the path to the module via the LLDB_SWIG_MODULE environment variable.
    add_sphinx_target(html lldb ENV_VARS "LLDB_SWIG_MODULE=${CMAKE_CURRENT_BINARY_DIR}")
    # Sphinx does not reliably update the custom CSS files, so force
    # a clean rebuild of the documentation every time.
    add_custom_target(clean-lldb-html COMMAND "${CMAKE_COMMAND}" -E
      remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html)
    add_dependencies(docs-lldb-html swig_wrapper_python
                     lldb-python-doc-package clean-lldb-html)
  endif()

  if (${SPHINX_OUTPUT_MAN})
    add_sphinx_target(man lldb)
  endif()
endif()

=== mlir/python/CMakeLists.txt ===
include(AddMLIRPython)

# Specifies that all MLIR packages are co-located under the `MLIR_PYTHON_PACKAGE_PREFIX.`
# top level package (the API has been embedded in a relocatable way).
add_compile_definitions("MLIR_PYTHON_PACKAGE_PREFIX=${MLIR_PYTHON_PACKAGE_PREFIX}.")
set(MLIRPythonModules_ROOT_PREFIX "${MLIR_BINARY_DIR}/${MLIR_BINDINGS_PYTHON_INSTALL_PREFIX}")
set(PYTHON_SOURCE_DIR "${MLIR_SOURCE_DIR}/lib/Bindings/Python")

################################################################################
# Structural groupings.
################################################################################

declare_mlir_python_sources(MLIRPythonSources)
declare_mlir_python_sources(MLIRPythonSources.Dialects
  ADD_TO_PARENT MLIRPythonSources)
declare_mlir_python_sources(MLIRPythonSources.Core
  ADD_TO_PARENT MLIRPythonSources)

################################################################################
# Pure python sources and generated code
################################################################################

declare_mlir_python_sources(MLIRPythonSources.Core.Python
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources.Core
  SOURCES
    _mlir_libs/__init__.py
    _mlir_libs/_mlir/py.typed
    ir.py
    passmanager.py
    rewrite.py
    dialects/_ods_common.py
    dialects/ext.py
)

declare_mlir_python_sources(MLIRPythonSources.Core.Python.Extras
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources.Core.Python
  SOURCES
    extras/types.py
    extras/meta.py
)

declare_mlir_python_sources(MLIRPythonSources.ExecutionEngine
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources
  SOURCES
    execution_engine.py
    _mlir_libs/_mlirExecutionEngine.pyi
  SOURCES_GLOB
    runtime/*.py
)

declare_mlir_python_sources(MLIRPythonCAPI.HeaderSources
  ROOT_DIR "${MLIR_SOURCE_DIR}/include"
  SOURCES_GLOB "mlir-c/*.h"
)

################################################################################
# Dialect bindings
################################################################################

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AffineOps.td
  SOURCES
    dialects/affine.py
  DIALECT_NAME affine
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AMDGPUOps.td
  SOURCES
    dialects/amdgpu.py
  DIALECT_NAME amdgpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AsyncOps.td
  SOURCES_GLOB dialects/async_dialect/*.py
  DIALECT_NAME async)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BufferizationOps.td
  SOURCES
    dialects/bufferization.py
  DIALECT_NAME bufferization
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Bufferization/IR/BufferizationEnums.td"
)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BuiltinOps.td
  SOURCES
    dialects/builtin.py
  DIALECT_NAME builtin)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ComplexOps.td
  SOURCES
    dialects/complex.py
  DIALECT_NAME complex)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/IndexOps.td
  SOURCES
    dialects/index.py
  DIALECT_NAME index
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ControlFlowOps.td
  SOURCES
    dialects/cf.py
  DIALECT_NAME cf)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/FuncOps.td
  SOURCES
    dialects/func.py
  DIALECT_NAME func)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/OpenACCOps.td
  SOURCES
    dialects/openacc.py
  DIALECT_NAME acc
  DEPENDS acc_common_td
  )

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/GPUOps.td
  SOURCES_GLOB dialects/gpu/*.py
  DIALECT_NAME gpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LinalgOps.td
  SOURCES
  SOURCES_GLOB
    dialects/linalg/*.py
  DIALECT_NAME linalg
  DEPENDS LinalgOdsGen
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LLVMOps.td
  SOURCES
    dialects/llvm.py
  DIALECT_NAME llvm
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformPDLExtensionOps.td
  SOURCES
    dialects/transform/pdl.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_pdl_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformSMTExtensionOps.td
  SOURCES
    dialects/transform/smt.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_smt_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformDebugExtensionOps.td
  SOURCES
    dialects/transform/debug.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_debug_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformTuneExtensionOps.td
  SOURCES
    dialects/transform/tune.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_tune_extension)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformOps.td
  SOURCES
    dialects/transform/__init__.py
    _mlir_libs/_mlir/dialects/transform/__init__.pyi
  DIALECT_NAME transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Transform/IR/TransformAttrs.td"
)

declare_mlir_python_sources(
  MLIRPythonSources.Dialects.transform.extras
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  GEN_ENUM_BINDINGS
  SOURCES
    dialects/transform/extras/__init__.py)

declare_mlir_python_sources(
  MLIRPythonSources.Dialects.transform.interpreter
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  SOURCES
    dialects/transform/interpreter/__init__.py)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BufferizationTransformOps.td
  SOURCES
    dialects/transform/bufferization.py
  DIALECT_NAME transform
  EXTENSION_NAME bufferization_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/GPUTransformOps.td
  SOURCES
    dialects/transform/gpu.py
  DIALECT_NAME transform
  EXTENSION_NAME gpu_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/SCFLoopTransformOps.td
  SOURCES
    dialects/transform/loop.py
  DIALECT_NAME transform
  EXTENSION_NAME loop_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MemRefTransformOps.td
  SOURCES
    dialects/transform/memref.py
  DIALECT_NAME transform
  EXTENSION_NAME memref_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVGPUTransformOps.td
  SOURCES
    dialects/transform/nvgpu.py
  DIALECT_NAME transform
  EXTENSION_NAME nvgpu_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LinalgStructuredTransformOps.td
  SOURCES
    dialects/transform/structured.py
  DIALECT_NAME transform
  EXTENSION_NAME structured_transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Linalg/TransformOps/LinalgTransformEnums.td"
)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/SparseTensorTransformOps.td
  SOURCES
    dialects/transform/sparse_tensor.py
  DIALECT_NAME transform
  EXTENSION_NAME sparse_tensor_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TensorTransformOps.td
  SOURCES
    dialects/transform/tensor.py
  DIALECT_NAME transform
  EXTENSION_NAME tensor_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/VectorTransformOps.td
  SOURCES
    dialects/transform/vector.py
  DIALECT_NAME transform
  EXTENSION_NAME vector_transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Vector/Transforms/VectorTransformsBase.td"
)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/XeGPUTransformOps.td
  SOURCES
    dialects/transform/xegpu.py
  DIALECT_NAME transform
  EXTENSION_NAME xegpu_transform)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MathOps.td
  SOURCES dialects/math.py
  DIALECT_NAME math)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ArithOps.td
  SOURCES
    dialects/arith.py
  DIALECT_NAME arith
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MemRefOps.td
  SOURCES
    dialects/memref.py
  DIALECT_NAME memref)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ShardOps.td
  SOURCES
    dialects/shard.py
  DIALECT_NAME shard
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MLProgramOps.td
  SOURCES
    dialects/ml_program.py
  DIALECT_NAME ml_program)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVGPUOps.td
  SOURCES
    dialects/nvgpu.py
  DIALECT_NAME nvgpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVVMOps.td
  SOURCES
    dialects/nvvm.py
  DIALECT_NAME nvvm
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects

=== mlir/python/requirements.txt ===
# BUILD dependencies
nanobind>=2.9, <3.0
PyYAML>=5.4.0, <=6.0.1
typing_extensions>=4.12.2
# RUN dependencies
numpy>=1.19.5, <=2.1.2
ml_dtypes>=0.1.0, <=0.6.0; python_version<"3.13"   # provides several NumPy dtype extensions, including the bf16
ml_dtypes>=0.5.0, <=0.6.0; python_version>="3.13"

=== libc/fuzzing/__support/CMakeLists.txt ===
add_libc_fuzzer(
  uint_fuzz
  SRCS
    uint_fuzz.cpp
  DEPENDS
    libc.src.__support.big_int
)

add_libc_fuzzer(
  hashtable_fuzz
  SRCS
    hashtable_fuzz.cpp
  DEPENDS
    libc.src.__support.HashTable.table
)

add_libc_fuzzer(
  hashtable_opt_fuzz
  SRCS
    hashtable_fuzz.cpp
  DEPENDS
    libc.hdr.types.ENTRY
    libc.src.__support.HashTable.table
  COMPILE_OPTIONS
    -D__LIBC_EXPLICIT_SIMD_OPT
)

add_libc_fuzzer(
  weak_avl_fuzz
  SRCS
    weak_avl_fuzz.cpp
  DEPENDS
    libc.src.__support.weak_avl
    libc.src.__support.CPP.optional
)

# TODO: FreeListHeap uses the _end symbol which conflicts with the _end symbol
# defined by GPU start.cpp files so for now we exclude this fuzzer on GPU.
if(LLVM_LIBC_FULL_BUILD AND NOT LIBC_TARGET_OS_IS_GPU)
  add_libc_fuzzer(
    freelist_heap_fuzz
    SRCS
      freelist_heap_fuzz.cpp
    DEPENDS
      libc.src.__support.freelist_heap
  )
  # TODO(#119995): Remove this once sccache on Windows no longer requires
  # the use of -DCMAKE_MSVC_DEBUG_INFORMATION_FORMAT=Embedded.
  get_fq_target_name(freelist_heap_fuzz freelist_heap_fuzz_target_name)
  set_target_properties(
    ${freelist_heap_fuzz_target_name}
    PROPERTIES
      MSVC_DEBUG_INFORMATION_FORMAT ""
  )
endif()

=== libc/hdr/types/CMakeLists.txt ===
add_proxy_header_library(
  char8_t
  HDRS
    char8_t.h
  DEPENDS
    libc.hdr.uchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.char8_t
    libc.include.uchar
)

add_proxy_header_library(
  char32_t
  HDRS
    char32_t.h
  DEPENDS
    libc.hdr.uchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.char32_t
    libc.include.uchar
)

add_proxy_header_library(
  mbstate_t
  HDRS
    mbstate_t.h
  DEPENDS
    libc.include.llvm-libc-types.mbstate_t
  FULL_BUILD_DEPENDS
    libc.include.uchar
)

add_proxy_header_library(
  div_t
  HDRS
    div_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.div_t
    libc.include.stdlib
)

add_proxy_header_library(
  struct_dl_phdr_info
  HDRS
    struct_dl_phdr_info.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_dl_phdr_info
)

add_proxy_header_library(
  ldiv_t
  HDRS
    ldiv_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ldiv_t
    libc.include.stdlib
)

add_proxy_header_library(
  lldiv_t
  HDRS
    lldiv_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.lldiv_t
    libc.include.stdlib
)

add_proxy_header_library(
  sigset_t
  HDRS
    sigset_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.sigset_t
)

add_proxy_header_library(
  struct_epoll_event
  HDRS
    struct_epoll_event.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_epoll_event
)

add_proxy_header_library(
  struct_flock
  HDRS
    struct_flock.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.hdr.stdint_proxy
    libc.include.llvm-libc-types.struct_flock
)

add_proxy_header_library(
  struct_flock64
  HDRS
    struct_flock64.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.hdr.stdint_proxy
    libc.include.llvm-libc-types.struct_flock64
)

add_proxy_header_library(
  struct_f_owner_ex
  HDRS
    struct_f_owner_ex.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_f_owner_ex
)

add_proxy_header_library(
  struct_timespec
  HDRS
    struct_timespec.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_timespec
)

add_proxy_header_library(
  struct_tm
  HDRS
    struct_tm.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_tm
)

add_proxy_header_library(
  size_t
  HDRS
    size_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.size_t
)

add_proxy_header_library(
  ssize_t
  HDRS
    ssize_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ssize_t
)

add_proxy_header_library(
  mode_t
  HDRS
    mode_t.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.mode_t
    libc.include.fcntl
)

add_proxy_header_library(
  fenv_t
  HDRS
    fenv_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.fenv_t
    libc.include.fenv
)

add_proxy_header_library(
  fexcept_t
  HDRS
    fexcept_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.fexcept_t
    libc.include.fenv
)

add_proxy_header_library(
  time_t
  HDRS
    time_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.time_t
    libc.include.time
)

add_proxy_header_library(
  clockid_t
  HDRS
    clockid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.clockid_t
)

add_proxy_header_library(
  clock_t
  HDRS
    clock_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.clock_t
    libc.include.time
)

add_proxy_header_library(
  suseconds_t
  HDRS
    suseconds_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.suseconds_t
    libc.include.sys_time
)

add_proxy_header_library(
  struct_timeval
  HDRS
    struct_timeval.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_timeval
    libc.include.sys_time
)

add_proxy_header_library(
  struct_itimerval
  HDRS
    struct_itimerval.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_itimerval
    libc.include.sys_time
)

add_proxy_header_library(
  pid_t
  HDRS
    pid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pid_t
)

add_proxy_header_library(
  pthread_barrier_t
  HDRS
    pthread_barrier_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pthread_barrier_t
)

add_proxy_header_library(
  pthread_barrierattr_t
  HDRS
    pthread_barrierattr_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pthread_barrierattr_t
)

add_proxy_header_library(
  atexithandler_t
  HDRS
    atexithandler_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.atexithandler_t
    libc.include.stdlib
)

add_proxy_header_library(
  struct_sigaction
  HDRS
    struct_sigaction.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sigaction
    libc.include.signal
)

add_proxy_header_library(
  FILE
  HDRS
    FILE.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.FILE
    libc.include.stdio
)

add_proxy_header_library(
  off_t
  HDRS
    off_t.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.off_t
    libc.include.stdio
)

add_proxy_header_library(
  cookie_io_functions_t
  HDRS
    cookie_io_functions_t.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.cookie_io_functions_t
    libc.include.stdio
)

add_proxy_header_library(
  locale_t
  HDRS
    locale_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.locale_t
    libc.include.locale
)

add_proxy_header_library(
  stack_t
  HDRS
    stack_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.stack_t
    libc.include.signal
)

add_proxy_header_library(
  jmp_buf
  HDRS
    jmp_buf.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.jmp_buf
    libc.include.setjmp
)

add_proxy_header_library(
  sigjmp_buf
  HDRS
    sigjmp_buf.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.sigjmp_buf
    libc.include.setjmp
)

add_proxy_header_library(
  struct_msghdr
  HDRS
    struct_msghdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_msghdr
    libc.include.sys_socket
)

add_proxy_header_library(
  struct_sockaddr
  HDRS
    struct_sockaddr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sockaddr
    libc.include.sys_socket
)

add_proxy_header_library(
  socklen_t
  HDRS
    socklen_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.socklen_t
    libc.include.sys_socket
)

add_proxy_header_library(
  wchar_t
  HDRS
    wchar_t.h
  DEPENDS
    libc.hdr.wchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.wchar_t
    libc.include.wchar
)

add_proxy_header_library(
  wint_t
  HDRS
    wint_t.h
  DEPENDS
    libc.hdr.wchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.wint_t
    libc.include.wchar
)

add_proxy_header_library(
  uid_t
  HDRS
    uid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.uid_t
)

add_proxy_header_library(
  struct_iovec
  HDRS
    struct_iovec.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_iovec
    libc.include.sys_uio
)

add_proxy_header_library(
  nfds_t
  HDRS
    nfds_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.nfds_t
)

add_proxy_header_library(
  struct_pollfd
  HDRS
    struct_pollfd.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_pollfd
)

add_proxy_header_library(
  cpu_set_t
  HDRS
    cpu_set_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.cpu_set_t
    libc.include.sched
)

add_proxy_header_library(
  ENTRY
  HDRS
    ENTRY.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ENTRY
    libc.include.search
)

add_proxy_header_library(
  ACTION
  HDRS
    ACTION.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ACTION
    libc.include.search
)

add_proxy_header_library(
  struct_sched_param
  HDRS
    struct_sched_param.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sched_param
    libc.include.sched
)

add_proxy_header_library(
  dl_info
  HDRS
    dl_info.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.dl_info
    libc.include.dlfcn
)

add_proxy_header_library(
  struct_rlimit
  HDRS
    struct_rlimit.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_rlimit
    libc.include.sys_resource
)

add_proxy_header_library(
  gid_t
  HDRS
    gid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.gid_t
)

add_proxy_header_library(
  Elf32_Addr
  HDRS
    Elf32_Addr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Addr
)

add_proxy_header_library(
  Elf32_Chdr
  HDRS
    Elf32_Chdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Chdr
)

add_proxy_header_library(
  Elf32_Dyn
  HDRS
    Elf32_Dyn.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Dyn
)

add_proxy_header_library(
  Elf32_Ehdr
  HDRS
    Elf32_Ehdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Ehdr
)

add_proxy_header_library(
  Elf32_Half
  HDRS
    Elf32_Half.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Half
)

add_proxy_header_library(
  Elf32_Lword
  HDRS
    Elf32_Lword.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Lword
)

add_proxy_header_library(
  Elf32_Nhdr
  HDRS
    Elf32_Nhdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Nhdr
)

add_proxy_header_library(
  Elf32_Off
  HDRS
    Elf32_Off.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Off
)

add_proxy_header_library(
  Elf32_Phdr
  HDRS
    Elf32_Phdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Phdr
)

add_proxy_header_library(
  Elf32_Rela
  HDRS
    Elf32_Rela.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Rela
)

add_proxy_header_library(
  Elf32_Rel
  HDRS
    Elf32_Rel.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Rel
)

add_proxy_header_library(
  Elf32_Shdr
  HDRS
    Elf32_Shdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Shdr
)

add_proxy_header_library(
  Elf32_Sword
  HDRS
    Elf32_Sword.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Sword
)

add_proxy_header_library(
  Elf32_Sym
  HDRS
    Elf32_Sym.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Sym
)

add_proxy_header_library(
  Elf32_Verdaux
  HDRS
    Elf32_Verdaux.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Verdaux
)

add_proxy_header_library(
  Elf32_Verdef
  HDRS
    Elf32_Verdef.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Verdef
)

add_proxy_header_library(
  Elf32_Vernaux
  HDRS
    Elf32_Vernaux.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Vernaux
)

add_proxy_header_library(
  Elf32_Verneed
  HDRS
    Elf32_Verneed.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Verneed
)

add_proxy_header_library(
  Elf32_Versym
  HDRS
    Elf32_Versym.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Versym
)

add_proxy_header_library(
  Elf32_Word
  HDRS
    Elf32_Word.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Word
)

add_proxy_header_library(
  Elf32_Xword
  HDRS
  Elf32_Xword.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf32_Xword
)

add_proxy_header_library(
  Elf64_Addr
  HDRS
    Elf64_Addr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Addr
)

add_proxy_header_library(
  Elf64_Chdr
  HDRS
    Elf64_Chdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Chdr
)

add_proxy_header_library(
  Elf64_Dyn
  HDRS
    Elf64_Dyn.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Dyn
)

add_proxy_header_library(
  Elf64_Ehdr
  HDRS
    Elf64_Ehdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Ehdr
)

add_proxy_header_library(
  Elf64_Half
  HDRS
    Elf64_Half.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Half
)

add_proxy_header_library(
  Elf64_Lword
  HDRS
    Elf64_Lword.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.Elf64_Lword
)

add_proxy_header_library(
  Elf64_Nhdr

=== debian/changelog ===
llvm-toolchain-snapshot (1:23~++20260204101751+dd02b404b020-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/rules: Mark usage of SLOPPY_BUILD to ease searching in the build log.
  * Update watch file, use with --force-download to fetch the integration
    testsuite.
  * Introduce an OMPD_ARCHS macro and use it.
  * Add a llvm.noclang build profile (not enabled by default).
  * Bump llvm-spirv build dependency to 21 again.
  * Introduce an LLVM_SPIRV_ARCHS macro and use it.
  * Don't run the omp autopkg test on i386. Closes: #1118644.
  * d/tests/control.in: Add test dependency on g++-multilib. Closes: #1118643.
  * d/debian-llvm-testsuite.bats: Skip test. Closes: #1118641.
    The test "pthread_cancel with libunwind compatibility" is wrong.
  * d/tests/control.in: Add test dependency on binutils-gold. Closes: #1118646.
  * Introduce CLANG_GRPC_ARCHS macro and use it.
  * Also use the grpc bits for clang on i386.
  * Add the alternate hello b-d for grpc related build dependencies.
  * Add profile to ocaml build dependencies.
  * Re(?)-enable omp on i386.
  * d/control: Only use one build profile per binary package for now. The ORing
    of build profiles seems to be not working.
  * Rename build profiles from llvm.* to pkg.llvm.*.
  * Fix some lintian warnings, override some more.
  * Clarify the libunwind package descriptions, that it is not compatible
    with glibc.
  * Only run the flang autopkg tests where flang is available.
  * Rename the LIBC_ARCHS macro to LLVM_LIBC_ARCHS, and only run the
    libllvmlibc autopkg tests where the package is available.
  * Fix removing *.pyc files and __pycache__ dirs during installation.
  * Fix some lintian warnings, override some more.
  * Copy libc++1, libc++abi1 and libomp5 symbols files from 21.
  * Build and install libflang_rt.runtime. Addresses: #1117534.
  * Fix liborc install on hurd-amd64.
  * Also call dh_python for the llvm-X.Y-tools package.
  * libunwind-X.Y-dev: Stop providing libunwind-dev. As updated in the
    package description, the unwinder is incompatible with glibc.
  * d/rules, d/*.{install,links,lintian-overrides}.in: Use a macro LLVM_LIBDIR.
  * Fix one more libclang1 lintian override.
  * Fix one more libc++-22-dev-wasm32 lintian override.
  * Update symbols files from the buildd logs, including i386.
  * Fix syntax for OR-ed build profiles.
  * clang-22-tools, llvm-22-tools: Use dh_python3 substvars.
  * liblldb-22: Move the .so symlink to the liblldb-22-dev package.
  * d/rules: Remove unnecessary use of the CURDIR macro.
  * Enable offloading on riscv64 (Aurelian Jarno).
  * Manually fix the python3 shebangs. dh_python3 can only handle one
    private directory. Also install lit first in the dh_override_install
    target, fix it there, and move it to the package from there.
  * Add build conflicts on llvm-22-runtime and clang-22, or else the
    wasm build picks up stuff from the installed llvm-22 and fails.
  * Stop building multilibs on s390x. Closes: #1125254.
  * Still build-depend on spirv-21.
  * d/llvm-X.Y-tools.bcep.in: Fix Python 3.14 byte compilation by adding
    an exception for shtest-encoding.py test file containing non-UTF-8
    characters (Igor Luppi). LP: #2138890.
  * Allow to build without CLC packages.
  * d/rules: Remove some invalid CLC targets.
  * Enable libunwind on s390x (Michael R. Crusoe). Addresses: #1126263.

  [ Sylvestre Ledru ]
  * new snapshot release for the 23 branch
  * grep is interpreting -Bno-symbolic as a context option.
  * Workaround the replaces/breaks on apt.llvm.org (upstream 167538)
  * flang: also ignore -fstack-protector-strong (happens on focal)
  * Rename ign_fail => ignore_if_fail
  * Fix file location for lintian source override.
  * mingw-w64 cross compilation is broken on focal, disable it
  * Remove patches/libclc-fix-prepare_builtins-rpath.diff
    for causing _Float16 is not supported on this target
  * Fix some libclc symlink

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 04 Feb 2026 10:19:12 +0100

=== debian/control ===
Source: llvm-toolchain-snapshot
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 11.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
    binutils-dev, lld [amd64 arm64 armel armhf i386 loong64 ppc64el riscv64 s390x],
    libxml2-dev,
    libipt-dev [amd64 i386],
    lcov, procps, help2man,
    zlib1g-dev, libzstd-dev,
    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32] | hello [amd64 i386 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32],
    libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
    doxygen, time,
    dh-exec, dh-python, ocaml-base [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml> | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>,
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
# "| hello" is for older buster/bionic distros without spirv support
# We need to keep the constraints coherent between the two alternatives, otherwise
# hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
    llvm-spirv-21 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    spirv-tools [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    wasi-libc | hello,
    mingw-w64-common,
    libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
    libgrpc++-dev [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    protobuf-compiler-grpc [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    libprotobuf-dev [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    protobuf-compiler [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
Build-Conflicts: oprofile, llvm-23-runtime, clang-23
Standards-Version: 4.7.2
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b snapshot
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/snapshot

# ------------- clang -------------

Package: clang-23
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc},
 libllvm23 (= ${binary:Version}),
 libclang-common-23-dev (= ${binary:Version}),
 llvm-23-linker-tools (= ${binary:Version}),
 libclang1-23 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler, objc++-compiler
Recommends: llvm-23-dev, python3, clang-tools-23
# libomp-23-dev
Suggests: clang-23-doc, wasi-libc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-23
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-23 (= ${binary:Version}),
 python3:any, ${python3:Depends}
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, etc.

Package: clang-format-23
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm23 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-23
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm23 (= ${binary:Version}),
 libclang-common-23-dev (= ${binary:Version}),
 clang-tools-23, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-23
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends},
 libllvm23 (= ${binary:Version}),
 libclang-common-23-dev (= ${binary:Version}),
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-23-doc
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-23
Build-Profiles: <!pkg.llvm.noclang>
Section: libs
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-23-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-23 (= ${binary:Version}),
 libclang-common-23-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-23.

Package: libclang-common-23-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: libclang-rt-23-dev
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers.

# ------------- compiler-rt -------------

Package: libclang-rt-23-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - development package
 This package provides various libraries:
 .
   * builtins - Simple libraries that provide implementation of the
     low-level target-specific hooks required by code generation
     and other runtime components.
   * sanitizer runtimes - AddressSanitizer, ThreadSanitizer,
     UndefinedBehaviorSanitizer, MemorySanitizer, LeakSanitizer
     DataFlowSanitizer, etc
   * profile - Library which is used to collect coverage information.

Package: libclang-rt-23-dev-wasm32
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm32 builtins
 Provides the compiler-rt builtins for WebAssembly 32 bits

Package: libclang-rt-23-dev-wasm64
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm64 builtins
 Provides the compiler-rt builtins for WebAssembly 64 bits

Package: libclang-rt-23-dev-win
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - Windows builtins
 Provides the compiler-rt builtins for Windows

# ------------- polly -------------

Package: libpolly-23-dev
Build-Profiles: <!pkg.llvm.noclang>

=== debian/rules ===
#!/usr/bin/make -f

EMPTY =
COMMA = ,
SPACE = $(EMPTY) $(EMPTY)

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform

DEB_BUILD_PROFILES := $(DEB_BUILD_PROFILES)
export DEB_BUILD_PROFILES

# FIXME: disable some PROJECTS according to build profiles
#ifeq (,$(filter pkg.llvm.noclang, $(DEB_BUILD_PROFILES)))
#  DEB_BUILD_PROFILES += pkg.llvm.noclang
#  $(warning LLVM PROFILES: enabled build profile pkg.llvm.noclang)
#endif

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
d = debian/tmp
DEB_INST		:= $(CURDIR)/$(d)

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

PYTHON3 := $(shell py3versions -d)
PY_EXT_SUFFIX := $(shell python3-config --extension-suffix)

PKG_VERSION := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_MINOR := $(shell echo $(PKG_VERSION)  | sed -rne "s,^1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
LLVM_VERSION_SNAPSHOT := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
	LLVM_VERSION_MINOR := 0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')
LLVM_DIR	= usr/lib/llvm-$(LLVM_VERSION)
LLVM_LIBDIR	= usr/lib/llvm-$(LLVM_VERSION)/lib

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
# remove +time64,+lfs once the time64_t transition starts
RUNTIMES = compiler-rt;libcxx;libcxxabi
ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
else
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
  else
    ifeq ($(DEB_HOST_ARCH),mips64el)
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
    else
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
    endif
  endif
endif

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)
DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
	NCPUS := $(shell nproc)
endif

# Check if a package meets version requirement
# Usage: $(call check_pkg_version,package-name,operator,version)
# Operators: ge (>=), gt (>), le (<=), lt (<), eq (=)
# Returns: yes or no
define check_pkg_version
$(shell v=$$(dpkg-query -W -f '$${Version}' $(1) 2>/dev/null); \
        if [ -z "$$v" ]; then \
            echo no; \
        elif dpkg --compare-versions "$$v" $(2) $(3); then \
            echo yes; \
        else \
            echo no; \
        fi)
endef

# Remove RPATH/RUNPATH from files matching a pattern
# Usage: $(call remove_rpath,file-pattern)
# Example: $(call remove_rpath,$(DEB_INST)/$(LLVM_DIR)/bin/*)
define remove_rpath
	for i in \
	  `chrpath -k $(1) 2>/dev/null | awk -F: '/R(UN)?PATH=/ {print $$$$1}'`; \
	do \
	  [ -h $$$$i ] && continue; \
	  chrpath -d $$$$i; \
	  echo "removed RPATH/RUNPATH: $$$$i"; \
	done
endef

# set this macro to anything else than "yes" to avoid generating alternative
# build dependencies on hello in the control file.
BD_ALT_HELLO = yes
ifeq ($(DERIVATIVE),Ubuntu)
BD_ALT_HELLO = no
endif

ifeq ($(BD_ALT_HELLO),yes)
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@//g;s/@END_OPTIONAL_HELLO@//g'
else
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@.*@END_OPTIONAL_HELLO@//'
endif

SKIP_COMMON_PACKAGES =
# for distro builds, skip these if a newer LLVM is in the distro series
ifeq ($(DERIVATIVE),Ubuntu)
  # list series which should not have the common packages
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
else ifeq ($(DERIVATIVE),Debian)
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
endif
# set these two when building without the common packages
#SKIP_COMMON_PACKAGES = yes
#NEW_LLVM_VERSION = 23

ifeq ($(SKIP_COMMON_PACKAGES),yes)
  COMMON_PKGS := $(shell cat debian/packages.common)
  COMMON_BUILD_DEPS = $(foreach p,$(COMMON_PKGS),$(p)$(COMMA))
  # make sure the common packages exist for the new LLVM version
  NEXT_LIBLLVM_PKG = libllvm$(NEW_LLVM_VERSION),
endif

# some object files are removed for space constraints during the build
# uncomment to keep everything during a build
# a SMALL_DISK build is 15GB + <2GB in the parent directory, the full build
# peaks out at 35GB + <2GB for the parent directory.
#SMALL_DISK = yes

# use sloppy builds to collect to
#   - ignore additional build artifacts
#   - ignore missing symbols in libraries
# look at these in the build logs and fix them in follow-up uploads
SLOPPY_BUILD =
ifeq (,$(filter $(DEB_HOST_ARCH), amd64XXX arm64XXX))
	SLOPPY_BUILD = yes
	ignore_if_fail = -
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# no 32bit support
FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64

ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
# this doesn't work, Ubuntu passes these in both positive and negative form, filter later
#    export DEB_BUILD_MAINT_OPTIONS += hardening=-stackprotector,-stackclash,-branch
endif

# flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
# based on the available memory
ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
  MEM_PER_CPU=6000
else
  MEM_PER_CPU=2100
endif

NJOBS := $(shell mt=`awk '/^(MemAvail|SwapFree)/ { mt += $$2 } END {print mt}' /proc/meminfo`; \
		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
		  'END { mt/=1024; n2 = int(mt/m); print n==1 || n2<=1 ? 1 : n2<=n ? n2 : n }' < /dev/null)

TIME_COMMAND = $(CURDIR)/debian/usage-wrapper.py $(SUMMARY_ONLY) -j $(NJOBS) --base-memory -m 4.0 -o usage-$(notdir $@)-$(DEB_HOST_ARCH).svg
TIME_BIN := $(if $(wildcard /usr/bin/time),/usr/bin/time,/bin/time)
TIME_COMMAND = $(TIME_BIN) -v
USAGE_BUILD_DEP = $(EMPTY) time,
ifneq (,$(findstring usage-wrapper, $(TIME_COMMAND)))
  ifeq ($(DERIVATIVE),Ubuntu)
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib [!i386],
    ifeq ($(DEB_HOST_ARCH),i386)
      SUMMARY_ONLY = --summary-only
    endif
  else
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
    ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
      TIME_COMMAND = $(TIME_BIN) -v
    endif
    ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32 hurd-i386 hurd-amd64))
      SUMMARY_ONLY = --summary-only
    endif
  endif
endif

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

=== debian/tests/control ===
Test-Command: ./debian/debian-llvm-testsuite.bats
Depends: @, cmake, make, g++, file, dpkg-dev, bats, bats-assert,
  binutils-gold [amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 powerpc ppc64 ppc64el s390x sparc64 x32],
  g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32],
# Comment the dbgsym package because of bug #917528
# dbgsym packages not being available in testing
# clang-23-dbgsym, libclang1-23-dbgsym
Restrictions: allow-stderr
Architecture: amd64 arm64 i386

Tests: integration-test-suite-test
Depends: @, cmake, make, g++
Restrictions: allow-stderr
Architecture: amd64 arm64

Tests: cmake-llvm-test
Depends: gcc, build-essential, cmake, llvm-23-dev

Tests: cmake-clang-test
Depends: gcc, build-essential, cmake, llvm-23-dev, clang-23, libclang-23-dev

Test-Command: python3 -c "import lldb; print(lldb.__file__); print(lldb)"
Depends: python3-lldb-23
Architecture: amd64 arm64 armel armhf i386 loong64 m68k ppc64el riscv64 s390x x32

Test-Command: python3 -c "import clang; print(clang.__file__); print(clang)"
Depends: python3-clang-23

=== debian/watch ===
version=4
opts=repack,compression=xz, \
  https://github.com/llvm/llvm-project/tags \
  (?:.*?/)?llvmorg-(23[\d\.\-]+).tar.gz

# FIXME: only works when using --force-download
# Newest version of integration-test-suite on remote site is 0.0~git20240518.a962677, local version is 22.1.x
opts=\
component=integration-test-suite,\
mode=git,\
pgpmode=none,\
repack,\
compression=xz \
  https://github.com/opencollab/llvm-toolchain-integration-test-suite \
  HEAD
